c +++++ Kaon two nucleon absorption  ++++++++++++++++++++++++++++++++
c ... common /RIDS/ reaction ID
c
c All		All with KN	  	:  - (with KN)	p1 : black
c KN		KN reaction  	:  1 (formation)	p1 : black
c tnL		none-mesic Lmbda	:  2 (reaction)	p1 : yellow
c tnS		none-mesic Sigma	:  3 (reaction)	p1 : blue
c pi_abs	pion absorption	:  4 (internal)	p1 : cyan
c SLC		Sigma-Lmbda conv 	:  5 (reaction)	p1 : green
c QFL		QF (mesic) Lmbda	:  6 (reaction)	p1 : magenta
c QFS		QF (mesic) Sigma	:  7 (reaction)	p1 : red
c CBG		const. background	:  8 (accidental)	p1 : blue
c
c -All	All without KN  	:  - (without KN)	p2 : black
c -KN		KN reaction		: -1 (KN decay)	p2 : black
c -tnL	none-mesic Lmbda	: -2 (L decay)	p2 : yellow
c -tnS	none-mesic Sigma	: -3 (S decay)	p2 : blue
c -pI_abs	pion absorption	: -4 (external)	p2 : cyan
c -SLC	igma-Lmbda conv	: -5 (L decay)	p2 : green
c -QFL	QF (mesic) Lmbda	: -6 (L decay)	p2 : magenta
c -QFS	QF (mesic) Sigma	: -7 (S decay)	p2 : red
c -pI_mono	pion abs mono	: -8 (external)	p2 : blue
c



      subroutine two_body_abs
      implicit NONE
c ... common /kaon/ for kaon trajectory
      real  kaon_point(3) ! position of the K-reaction
      real  kt_vector(3) ! trajectory of the kaon injection
      real  kt_point(3) ! position of the K-reaction
      real  K_stop_time, K_flight_time, dL_T0
      common /kaon/ kaon_point, kt_point, kt_vector, K_stop_time, K_flight_time, dL_T0
c ... common for K-nucleus two_body absorption branch
      real r_KN_2body(4), p_SL_conv_2N(4), p_Y_scat_2N(4), p_pi_scat_2N(4), p_pi_abs_2N(4)
      common /branch_2N/ r_KN_2body, p_SL_conv_2N, p_Y_scat_2N, p_pi_scat_2N, p_pi_abs_2N
c common for debug
	logical debug_F
      integer ev_NUM, ev_error
      common /DeBugging/ debug_F, ev_NUM, ev_error
c local
      real point(3), time, rand
c external
	real rn
c Kaon two body absorption
      time  = K_stop_time
      point(1) =  kaon_point(1)
      point(2) =  kaon_point(2)
      point(3) =  kaon_point(3)
      rand  = rn()
      if( rand .le. r_KN_2body(1)) then
c  ... K He4 -> d n L
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'K He4 -> d n L'
         call dnL( point, time )
      else  if( rand .le. r_KN_2body(2)) then
c ... K He4 -> S0 n d
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'K He4 -> S0 n d'
         call ndS0( point, time )
      else  if( rand .le. r_KN_2body(3)) then
c ... K He4 -> S- p d
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'K He4 -> S- p d'
         call pdSm( point, time )
      else  
c	else  if( rand .le. r_KN_2body(4)) then ! r_KN_2body(4) = 1.0
c ... K He4 -> S+ n n n
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'K He4 -> S+ n n n'
         call nnnSp(point, time)
      endif
      return
      end





      subroutine dnL( point, time )
      implicit NONE
c  ... K He4 -> d n L
c input
      real point(3), time
c common
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common /branch_1N_2N/ for single nucleon reaction ratio
	real  r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_2N_3N_piEx_abs
	common /branch_1N_2N/ r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_2N_3N_piEx_abs
c ... common /LPNN/
	real r_2N_3N_K2NL_pn
	common /LPNN/ r_2N_3N_K2NL_pn
c ... common for K-nucleus two_body absorption branch
      real r_KN_2body(4), p_SL_conv_2N(4), p_Y_scat_2N(4)
      common /branch_2N/ r_KN_2body, p_SL_conv_2N, p_Y_scat_2N
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c local
      real rn, p_n, v_n(3)
      real p_L, v_L(3), p_deuteron, v_deuteron(3)
      real p_n2, v_n2(3), p_p2, v_p2(3)
      integer iflag, N_nucl, N_pickup
	integer reactionID / 1 /
c begin
      N_nucl = 4
      iflag = 0
	if(rn() .lt. r_2N_3N_K2NL) then
c  ... K He4 -> L n d
	   if(rn() .lt. r_2N_3N_K2NL_pn) then
            N_pickup = 2 
            call reaction_at_rest_3( M_helium4, M_k, 
     &            M_L, M_n, M_deuteron,
     &            p_L, p_n, p_deuteron, 
     &            v_L, v_n, v_deuteron, N_nucl, N_pickup, iflag)
	   else
           N_pickup = 2 
           call breakup_at_rest_4( M_helium4, M_k, 
     &            M_L, M_p,  M_n,  M_n,  
     &            p_L, p_p2, p_n,  p_n2, 
     &            v_L, v_p2, v_n,  v_n2, N_nucl, N_pickup, iflag)
           call put_stack(PID_neutron, p_n, v_n,  point, time, tnL)
           call put_stack(PID_neutron, p_n2, v_n2,  point, time, tnL)
           call put_stack(PID_proton, p_p2, v_p2, point, time, tnL)
           call put_stack(PID_Lambda, p_L, v_L, point, time, tnL)
	     return
	   endif
	else
c  ... K He4 -> p n n L
         N_nucl = 4
         N_pickup = 3 
         iflag = 0
	   if(rn() .lt. 0.5) then
            call reaction_at_rest_4( M_helium4, M_k, 
     &            M_L, M_n, M_n,  M_p,    
     &            p_L, p_n, p_n2, p_p2, 
     &            v_L, v_n, v_n2, v_p2, N_nucl, N_pickup, iflag)
	   else
           call reaction_at_rest_4( M_helium4, M_k, 
     &            M_L, M_p,  M_n,  M_n,  
     &            p_L, p_p2, p_n,  p_n2, 
     &            v_L, v_p2, v_n,  v_n2, N_nucl, N_pickup, iflag)
	   endif
         call put_stack(PID_neutron, p_n, v_n,  point, time, tnL)
         call put_stack(PID_neutron, p_n2, v_n2,  point, time, tnL)
         call put_stack(PID_proton, p_p2, v_p2, point, time, tnL)
         call put_stack(PID_Lambda, p_L, v_L, point, time, tnL)
	   return
	endif
c ... YN scattering
	if( rn() .lt. p_Y_scat_2N(reactionID) ) then
         call put_stack(PID_neutron, p_n, v_n,  point, time, tnL)
	   call internal_deuteron_scattering(
     &		PID_deuteron, M_deuteron, p_deuteron, v_deuteron,
     &		PID_Lambda, M_L, p_L, v_L, r_1N_2N_LNS, point, time, tnL)
	   return
	endif
c ... without 2ndary reaction
      call put_stack(PID_neutron, p_n, v_n,  point, time, tnL)
      call put_stack(PID_Lambda, p_L, v_L, point, time, tnL)
      call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, tnL)
	return
      end





      subroutine ndS0( point, time )
      implicit NONE
c ... K He4 -> S0 n d
c input
      real point(3), time
c common
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common /branch_1N_2N/ for single nucleon reaction ratio
	real  r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_2N_3N_piEx_abs
	common /branch_1N_2N/ r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_2N_3N_piEx_abs
c ... common for K-nucleus two_body absorption branch
      real r_KN_2body(4), p_SL_conv_2N(4), p_Y_scat_2N(4)
      common /branch_2N/ r_KN_2body, p_SL_conv_2N, p_Y_scat_2N
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c local
      real rn, p_n, v_n(3)
      real p_deuteron, v_deuteron(3)
      real p_S0, v_S0(3), p_n2, v_n2(3)
      real p_p2, v_p2(3)
      integer iflag, N_nucl, N_pickup
	integer reactionID / 2 /
c begin
      N_nucl = 4
      iflag = 0
c ... K He4 -> S0 n d
	if(rn() .lt. r_2N_3N_K2NS) then
           N_pickup = 2 
           call reaction_at_rest_3( M_helium4, M_k, 
     &            M_S0, M_n, M_deuteron,
     &            p_S0, p_n, p_deuteron, 
     &            v_S0, v_n, v_deuteron, N_nucl, N_pickup, iflag)
c ... K He4 -> S0 n n p
	else
         N_pickup = 3 
	   if(rn() .lt. 0.5) then
            call reaction_at_rest_4( M_helium4, M_k, 
     &            M_S0, M_n, M_n,  M_p, 
     &            p_S0, p_n, p_n2, p_p2, 
     &            v_S0, v_n, v_n2, v_p2, N_nucl, N_pickup, iflag)
	   else
            call reaction_at_rest_4( M_helium4, M_k, 
     &            M_S0, M_p,  M_n, M_n,  
     &            p_S0, p_p2, p_n, p_n2, 
     &            v_S0, v_p2, v_n, v_n2, N_nucl, N_pickup, iflag)
	   endif
         call put_stack(PID_Sigma0, p_S0, v_S0, point, time, tnS)
         call put_stack(PID_neutron, p_n, v_n,  point, time, tnS)
         call put_stack(PID_neutron, p_n2, v_n2,  point, time, tnS)
         call put_stack(PID_proton, p_p2, v_p2, point, time, tnS)
	   return
	endif
c ... SL conversion
	if( rn() .lt. p_SL_conv_2N(reactionID) ) then
         call put_stack(PID_neutron, p_n, v_n,  point, time, tnS)
	   call deuteron_SL_conversion(M_deuteron, p_deuteron, v_deuteron,
     &		M_S0, p_S0, v_S0, r_1N_2N_SLC, point, time, SLC)
	   return
	endif
c ... YN scattering
	if( rn() .lt. p_Y_scat_2N(reactionID) ) then
         call put_stack(PID_neutron, p_n, v_n,  point, time, tnS)
	   call internal_deuteron_scattering(
     &		PID_deuteron, M_deuteron, p_deuteron, v_deuteron,
     &		PID_Sigma0, M_S0, p_S0, v_S0, r_1N_2N_LNS, point, time, tnS)
	   return
	endif
c ... without 2ndary reaction
      call put_stack(PID_neutron, p_n, v_n,  point, time, tnS)
      call put_stack(PID_Sigma0, p_S0, v_S0, point, time, tnS)
      call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, tnS)
      return
      end




      subroutine pdSm( point, time )
      implicit NONE
c ... K He4 -> S- p d
c input
      real point(3), time
c common
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common /branch_1N_2N/ for single nucleon reaction ratio
	real  r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_2N_3N_piEx_abs
	common /branch_1N_2N/ r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_2N_3N_piEx_abs
c ... common for K-nucleus two_body absorption branch
      real r_KN_2body(4), p_SL_conv_2N(4), p_Y_scat_2N(4)
      common /branch_2N/ r_KN_2body, p_SL_conv_2N, p_Y_scat_2N
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c common for debug
	logical debug_F
      integer ev_NUM, ev_error
      common /DeBugging/ debug_F, ev_NUM, ev_error
c local
      real rn
      real p_p, v_p(3), p_deuteron, v_deuteron(3)
      real p_Sm, v_Sm(3), p_n2, v_n2(3)
      real p_p2, v_p2(3), p_p3, v_p3(3)
      integer iflag, N_nucl, N_pickup
	integer reactionID / 3 /
c begin
      N_nucl = 4
	iflag = 0
c ... K He4 -> S- p d
	if(rn() .lt. r_2N_3N_K2NS) then
c>	     if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'S- p d'
           N_pickup = 2 
           call reaction_at_rest_3( M_helium4, M_k, 
     &            M_Sm, M_p, M_deuteron,
     &            p_Sm, p_p, p_deuteron, 
     &            v_Sm, v_p, v_deuteron, N_nucl, N_pickup, iflag)
	else
c ... K He4 -> S- n p p
c>	   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'S- n p p'
         N_pickup = 3 
	   if(rn() .lt. 1./2.) then
            call reaction_at_rest_4( M_helium4, M_k, 
     &            M_Sm, M_p,  M_p,  M_n,  
     &            p_Sm, p_p2, p_p3, p_n2, 
     &            v_Sm, v_p2, v_p3, v_n2, N_nucl, N_pickup, iflag)
	   else
            call reaction_at_rest_4( M_helium4, M_k, 
     &            M_Sm, M_n,  M_p,  M_p,  
     &            p_Sm, p_n2, p_p2, p_p3, 
     &            v_Sm, v_n2, v_p2, v_p3, N_nucl, N_pickup, iflag)
	   endif
         call put_stack(PID_SigmaM, p_Sm, v_Sm,  point, time, tnS)
         call put_stack(PID_proton, p_p2, v_p2, point, time, tnS)
         call put_stack(PID_proton, p_p3, v_p3, point, time, tnS)
         call put_stack(PID_neutron, p_n2, v_n2,  point, time, tnS)
	   return
	endif
c ... SL conversion
	if( rn() .lt. p_SL_conv_2N(reactionID) ) then
         call put_stack(PID_proton, p_p, v_p, point, time, tnS)
	   call deuteron_SL_conversion(M_deuteron, p_deuteron, v_deuteron,
     &		M_Sm, p_Sm, v_Sm, r_1N_2N_SLC, point, time, SLC)
	   return
	endif
c ... YN scattering
	if( rn() .lt. p_Y_scat_2N(reactionID) ) then
         call put_stack(PID_proton, p_p, v_p, point, time, tnS)
	   call internal_deuteron_scattering(
     &		PID_deuteron, M_deuteron, p_deuteron, v_deuteron,
     &		PID_SigmaM, M_Sm, p_Sm, v_Sm, r_1N_2N_LNS, point, time, tnS)
	   return
	endif
c ... without 2ndary reaction
      call put_stack(PID_proton, p_p, v_p, point, time, tnS)
      call put_stack(PID_SigmaM, p_Sm, v_Sm, point, time, tnS)
      call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, tnS)
      return
      end




      subroutine nnnSp(point, time)
      implicit NONE
c ... K He4 -> S+ n n n
      real point(3), time, rn
c common
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common /branch_1N_2N/ for single nucleon reaction ratio
	real  r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_2N_3N_piEx_abs
	common /branch_1N_2N/ r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_2N_3N_piEx_abs
c ... common for K-nucleus two_body absorption branch
      real r_KN_2body(4), p_SL_conv_2N(4), p_Y_scat_2N(4)
      common /branch_2N/ r_KN_2body, p_SL_conv_2N, p_Y_scat_2N
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c local
      real p_Sp, v_Sp(3)
      real p_n1, v_n1(3), p_n2, v_n2(3), p_n3, v_n3(3)
      integer iflag, N_nucl, N_pickup
c	integer reactionID / 4 /
c begin
	N_nucl = 4
	iflag = 0
	if(rn() .lt. r_2N_3N_K2NS) then
         N_pickup = 2 
         call breakup_at_rest_4( M_helium4, M_k, 
     &	M_Sp, M_n,  M_n,  M_n,  
     &      p_Sp, p_n1, p_n2, p_n3, 
     &	v_Sp, v_n1, v_n2, v_n3, N_nucl, N_pickup, iflag )
	else
         N_pickup = 3 
         call reaction_at_rest_4( M_helium4, M_k, 
     &	M_Sp, M_n,  M_n,  M_n,  
     &      p_Sp, p_n1, p_n2, p_n3, 
     &	v_Sp, v_n1, v_n2, v_n3, N_nucl, N_pickup, iflag )
	endif
      call put_stack(PID_SigmaP, p_Sp, v_Sp, point, time, tnS)
      call put_stack(PID_neutron, p_n1, v_n1, point, time, tnS)
      call put_stack(PID_neutron, p_n2, v_n2, point, time, tnS)
      call put_stack(PID_neutron, p_n3, v_n3, point, time, tnS)
      return
      end



