c +++ io +++++++++++++++++++++++++++++++++++++++++++





      subroutine read_quasi_free_branch
      implicit NONE
c ... common primary reaction ratio
      real  r_knucl, r_two_nucl, r_quasi_free, r_Lambda_Hyper, r_Sigma_Hyper
      common /prim_ratio/ r_knucl, r_two_nucl, r_quasi_free, r_Lambda_Hyper, r_Sigma_Hyper
c ... common for QF branch
      real p_quasi(8), p_SL_conv(8), p_Y_scat(8), p_pi_scat(8), p_pi_abs(8)
      common /branch/ p_quasi, p_SL_conv, p_Y_scat, p_pi_scat, p_pi_abs
c ... common for K-nucleus two_body absorption branch
      real r_KN_2body(4), p_SL_conv_2N(4), p_Y_scat_2N(4)
      common /branch_2N/ r_KN_2body, p_SL_conv_2N, p_Y_scat_2N
c ... common /branch_1N_2N/ for single nucleon reaction ratio
	real  r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_2N_3N_piEx_abs
	common /branch_1N_2N/ r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_2N_3N_piEx_abs
c ... common /LPNN/
	real r_2N_3N_K2NL_pn
	common /LPNN/ r_2N_3N_K2NL_pn
c ... common for hypernuclei
	real B_Sp0, G_Sp0, B_L0, G_L0
	common /HyperBND/ B_Sp0, G_Sp0, B_L0, G_L0
	real B_KN, G_KN
	common /K_Nucl/ B_KN, G_KN
c ... common for KN_decay
	real decay_branch(8)
	common /KN_decay/ decay_branch(8)
c ... commpn for scale
	real Lpim_Lpi0_R, Spi0_R
	common /scale/ Lpim_Lpi0_R, Spi0_R
c ... common /setup/ for simulation run-condition, counter resolution and its efficiency
	integer FF_knucl_decay, multi_set, k_decay_set
	logical Kstop_cor
      real  delta_x, delta_y, delta_T0, delta_NC, TC_eff, T0_eff
      common /setup/ delta_x, delta_y, delta_T0, delta_NC, TC_eff, T0_eff,
     &	FF_knucl_decay, multi_set, k_decay_set, Kstop_cor
c ... common /F_KN/ for knucl Fermi-motion enlaging factor and SL conversion
	logical Fermi_Knucl
	real SLC_KN_Spp, SLC_KN_Spn, SLC_KN_Snn
	common /F_KN/ Fermi_Knucl, SLC_KN_Spp, SLC_KN_Spn, SLC_KN_Snn
c ... common for total kaon number
	integer Knum
	common /KTOT/ Knum
c ... common for /VDC/ VDC specification
	real VDC_resolution, VDC_threshold
	common /VDC/ VDC_resolution, VDC_threshold
c ... common /DIRS/ for save directory name
	character*80 DirSave
	integer DirL
	common /DIRS/ DirSave, DirL
c ... constant /CBGL/ for constant neutron background level
	real CBG_level
	common /CBGL/ CBG_level
c ... constant /NDPT/ for constant neutron background level
	real n_prod_dpit
	common /NDPT/ n_prod_dpit
c ... /FKS/ 
	logical FakeS
	common /FKS/ FakeS
c ...	comments common
	character*180 comments
	common /CMNTS/ comments
c local
	character*180 dummy
	real w_conv, p_Pauli, kw_conv
	integer iKstop_cor, j, iFakeS
c begin
	Fermi_Knucl = .false.
      Open ( unit = 1, file = 'knucl_input.dat', status = 'unknown' )
	read(1,111) DirSave
111	format(a)
	Do j = 3, 40
	  if( DirSave(j:j) .eq. '/' ) go to 10
c	   write(*,*) j, DirSave(j:j)
	EndDo
10	DirL = j
	read(1,*) Knum, dummy
	write(*,*) 'Total Kaon Number to be generated =', Knum*0.1, ' (M) events'
c ###### branching ratio to K_Nucl ######
	read(1,*) dummy
	read(1,*) r_knucl, B_KN, G_KN, dummy
c ###### K-nucl decay branch ###### not well known obiously
	read(1,*) dummy
	read(1,*) decay_branch(1), dummy
	read(1,*) decay_branch(2), dummy
	read(1,*) decay_branch(3), dummy
	read(1,*) decay_branch(4), dummy
	read(1,*) decay_branch(5), dummy
	read(1,*) decay_branch(6), dummy
	read(1,*) decay_branch(7), dummy
	read(1,*) decay_branch(8), dummy
c ###### K-nucl SL conversion strength
	read(1,*) dummy
	read(1,*) kw_conv , dummy 
      SLC_KN_Spp = 2. * kw_conv 
      SLC_KN_Spn = kw_conv 
      SLC_KN_Snn = 2. * kw_conv 
c ###### ratio between QF and Non-mesic kaon absorption ######
	read(1,*) dummy
	read(1,*) r_two_nucl, dummy
	read(1,*) r_quasi_free, dummy
c ###### QF branches (pion production) ######OXO|XRWR[TURT
c QF branch for each process (1) - (7)'s are Outa's notation
c     (5) = (4),  (7) = 2(Lpim_Lpi0_R)*(6),  (1) + (2) - (5)  = 2(Spi0_R)*(3)
	read(1,*) dummy
	read(1,*) dummy
	read(1,*) dummy
c Lpim_Lpi0_R = Spi0_R = 2, if isospin conserve
	read(1,*) dummy
	read(1,*) Lpim_Lpi0_R, dummy
	read(1,*) Spi0_R, dummy
c
	read(1,*) p_quasi(1), dummy
	read(1,*) p_quasi(2), dummy
	read(1,*) p_quasi(5), dummy
	read(1,*) p_quasi(7), dummy
	read(1,*) p_quasi(8), dummy
      p_quasi(4) = p_quasi(5)
      p_quasi(3) = (p_quasi(1) + p_quasi(2) - p_quasi(5) ) / Spi0_R
      p_quasi(6) = p_quasi(7) / Lpim_Lpi0_R
c # SL conversion strength
	read(1,*) dummy
	read(1,*) w_conv , dummy 
	read(1,*) p_Pauli, dummy
      p_SL_conv(1) = 4. * w_conv 
      p_SL_conv(2) = 2. * w_conv 
      p_SL_conv(3) = 3. * w_conv 
      p_SL_conv(4) = 4. * w_conv 
      p_SL_conv(5) = 3. * w_conv 
      p_SL_conv(6) = 0.
      p_SL_conv(7) = 0.
      p_SL_conv(8) = 0.
c # Hyperon scattering (nuclear breakup)
	read(1,*) dummy
	read(1,*) p_Y_scat(1), dummy
	read(1,*) p_Y_scat(2), dummy
	read(1,*) p_Y_scat(3), dummy
	read(1,*) p_Y_scat(4), dummy
	read(1,*) p_Y_scat(5), dummy
	read(1,*) p_Y_scat(6), dummy
	read(1,*) p_Y_scat(7), dummy
	p_Y_scat(8) = 0.
c # pion scattering (nuclear breakup)
	read(1,*) dummy
	read(1,*) p_pi_scat(1), dummy
	read(1,*) p_pi_scat(2), dummy
	read(1,*) p_pi_scat(3), dummy
	read(1,*) p_pi_scat(4), dummy
	read(1,*) p_pi_scat(5), dummy
	read(1,*) p_pi_scat(6), dummy
	read(1,*) p_pi_scat(7), dummy
	p_pi_scat(8) = 0.
c # pion internal absorption (nuclear breakup)
	read(1,*) dummy
	read(1,*) p_pi_abs(1), dummy
	read(1,*) p_pi_abs(2), dummy
	read(1,*) p_pi_abs(3), dummy
	read(1,*) p_pi_abs(4), dummy
	read(1,*) p_pi_abs(5), dummy
	read(1,*) p_pi_abs(6), dummy
	read(1,*) p_pi_abs(7), dummy
	p_pi_abs(8) = 0.
c # 1N reaction probability (if <1, it go to NN inital reaction)
c       common for primary reaction 
	read(1,*) dummy  
	read(1,*) dummy 
	read(1,*) r_1N_2N_S, dummy
	read(1,*) r_1N_2N_L, dummy
	read(1,*) r_1N_2N_SLC, dummy
	read(1,*) r_1N_2N_SNS, dummy
	read(1,*) r_1N_2N_LNS, dummy
	read(1,*) r_1N_2N_piS, dummy
c ###### two nucleon K absorption branches (without pion production) ######
c     (2) = ( (3) + (4) ) / 2,    (2) = K- He4 -> Sigma0 n d
	read(1,*) dummy
	read(1,*) dummy
	read(1,*) r_KN_2body(1), dummy
	read(1,*) r_KN_2body(3), dummy
	read(1,*) r_KN_2body(4), dummy
	r_KN_2body(2) = ( r_KN_2body(3) + r_KN_2body(4) ) / 2.
c # SL conversion strength for 2NK:    (1) = (4) = 0
	read(1,*) dummy
	read(1,*) p_SL_conv_2N(2), dummy
	read(1,*) p_SL_conv_2N(3), dummy
	p_SL_conv_2N(1) = 0.
	p_SL_conv_2N(4) = 0.
c # YN scattering strength for 2NK:    (4) = 0
	read(1,*) dummy
	read(1,*) p_Y_scat_2N(1), dummy
	read(1,*) p_Y_scat_2N(2), dummy
	read(1,*) p_Y_scat_2N(3), dummy
	p_Y_scat_2N(4) = 0.
c # 2N reaction probability <----
	read(1,*) dummy
	read(1,*) r_2N_3N_K2NS, dummy
	read(1,*) r_2N_3N_K2NL, dummy
	read(1,*) r_2N_3N_piEx_abs, dummy
c ###### Hypernuclear data ######
c hypernuclear Binding energies
	read(1,*) dummy
	read(1,*) dummy
	read(1,*) r_Sigma_Hyper, dummy
	read(1,*) B_Sp0
	read(1,*) G_Sp0
	read(1,*) r_Lambda_Hyper, dummy
	read(1,*) B_L0
	read(1,*) G_L0
c ###### global simulation condition ###### 
	read(1,*) dummy
	read(1,*) delta_x, dummy	! NC thickness (cm) 	
	read(1,*) delta_y, dummy	! NC position resolution (sigma in cm)
	read(1,*) delta_T0, dummy	! T0 counter time resolution (nsec)
	read(1,*) delta_NC, dummy	! neutron counter time resolution (nsec)
	read(1,*) TC_eff, dummy		! TC light-guide acceptance
	read(1,*) T0_eff, dummy		! T0 light-guide acceptance
	read(1,*) multi_set, dummy	! Coulomb scattering ON(=1)/OFF(=0)
	read(1,*) k_decay_set, dummy	! kaon decay ON(=1)/OFF(=0)
	read(1,*) iKstop_cor, dummy	! T0-time correction ON(=1)/Skip(=0)
	read(1,*) FF_knucl_decay, dummy	! Apply nuclear formfactor ON(=1)/OFF(=0)
	read(1,*) CBG_level, dummy	! neutron constant background level
	Kstop_cor = .false.
	if( iKstop_cor .eq. 1 ) Kstop_cor = .true.
c ###### additional parameter for K4He -> Lnd / Lpnn ###### 
	read(1,*) dummy
	read(1,*) r_2N_3N_K2NL_pn, dummy	! K4He -> Lnd prob. originary = 100%
c ###### additional parameter for nutron production durling pion travel ###### 
	read(1,*) dummy
	read(1,*) n_prod_dpit, dummy		! pi N -> pi N originary = 0%
c ###### additional parameter for VDC threshold and VDC resolution ###### 
	read(1,*) dummy
	read(1,*) VDC_resolution, dummy	! (MeV)
	read(1,*) VDC_threshold, dummy	! (cm)
c ###### Fake simulation without S+/- energy loss ###### 
	read(1,*) dummy
	read(1,*) iFakeS, dummy	! (ON=1)/(OFF=0)
	if(iFakeS.eq.1) then 
	   FakeS = .true.
	else 
	   FakeS = .false.
	endif
c ###### comments on why I did this simulation condition ###### 
	read(1,*) dummy
	read(1,*) dummy
	comments = dummy	
c
	close(1)
	return
	end





      subroutine normalize_branch
      implicit NONE
c ... common primary reaction ratio
      real  r_knucl, r_two_nucl, r_quasi_free, r_Lambda_Hyper, r_Sigma_Hyper
      common /prim_ratio/ r_knucl, r_two_nucl, r_quasi_free, r_Lambda_Hyper, r_Sigma_Hyper
c ... common for QF branch
      real p_quasi(8), p_SL_conv(8), p_Y_scat(8), p_pi_scat(8), p_pi_abs(8)
      common /branch/ p_quasi, p_SL_conv, p_Y_scat, p_pi_scat, p_pi_abs
c ... common for K-nucleus two_body absorption branch
      real r_KN_2body(4), p_SL_conv_2N(4), p_Y_scat_2N(4)
      common /branch_2N/ r_KN_2body, p_SL_conv_2N, p_Y_scat_2N
c ... common /branch_1N_2N/ for single nucleon reaction ratio
	real  r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_2N_3N_piEx_abs
	common /branch_1N_2N/ r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_2N_3N_piEx_abs
c ... common /LPNN/
	real r_2N_3N_K2NL_pn
	common /LPNN/ r_2N_3N_K2NL_pn
c common for hypernuclei
	real B_Sp0, G_Sp0, B_L0, G_L0
	common /HyperBND/ B_Sp0, G_Sp0, B_L0, G_L0
	real B_KN, G_KN
	common /K_Nucl/ B_KN, G_KN
c common for branch check
      real H3_pim_Sp, dn_pim_Sp, pnn_pim_Sp, nnn_pi0_Sp, nnn_Sp, tot_Sp
      real H3_pip_Sm, dn_pip_Sm, pnn_pip_Sm, He3_pi0_Sm, dp_pi0_Sm
      real ppn_pi0_Sm, dp_Sm, ppn_Sm, tot_Sm
      real He3_pim_L, dp_pim_L, ppn_pim_L, He3_pim_S0, dp_ppn_pim_S0
      real dn_pnn_pi0_L_S0, dn_pnn_L_S0, nnn_pip_L_S0, tot_L_S0   
      real ext_Sm_conv
      common /branch_check/  H3_pim_Sp, dn_pim_Sp, pnn_pim_Sp
     &      , nnn_pi0_Sp, nnn_Sp, tot_Sp
     &      , H3_pip_Sm, dn_pip_Sm, pnn_pip_Sm, He3_pi0_Sm, dp_pi0_Sm
     &      , ppn_pi0_Sm, dp_Sm, ppn_Sm, tot_Sm
     &      , He3_pim_L, dp_pim_L, ppn_pim_L, He3_pim_S0, dp_ppn_pim_S0
     &      , dn_pnn_pi0_L_S0, dn_pnn_L_S0, nnn_pip_L_S0, tot_L_S0
     &      , ext_Sm_conv
      real L_hyp_mesic, L_pi0_t, S0_pi0_t, L_hyp_nmesic
      common /branch_misc/  L_hyp_mesic, L_pi0_t, S0_pi0_t, L_hyp_nmesic
c common for KN_decay
	real decay_branch(8)
	common /KN_decay/ decay_branch(8)
c common for scale
	real Lpim_Lpi0_R, Spi0_R
	common /scale/ Lpim_Lpi0_R, Spi0_R
c ... common /setup/ for simulation run-condition, counter resolution and its efficiency
	integer FF_knucl_decay, multi_set, k_decay_set
	logical Kstop_cor
      real  delta_x, delta_y, delta_T0, delta_NC, TC_eff, T0_eff
      common /setup/ delta_x, delta_y, delta_T0, delta_NC, TC_eff, T0_eff,
     &	FF_knucl_decay, multi_set, k_decay_set, Kstop_cor
c common /F_KN/ for knucl Fermi-motion enlaging factor and SL conversion
	logical Fermi_Knucl
	real SLC_KN_Spp, SLC_KN_Spn, SLC_KN_Snn
	common /F_KN/ Fermi_Knucl, SLC_KN_Spp, SLC_KN_Spn, SLC_KN_Snn
c ... common /DIRS/ for save directory name
	character*80 DirSave
	integer DirL
	common /DIRS/ DirSave, DirL
c ... constant /CBGL/ for constant neutron background level
	real CBG_level
	common /CBGL/ CBG_level
c ... constant /NDPT/ for constant neutron background level
	real n_prod_dpit
	common /NDPT/ n_prod_dpit
c ... common for /VDC/ VDC specification
	real VDC_resolution, VDC_threshold
	common /VDC/ VDC_resolution, VDC_threshold
c common for total kaon number
	integer Knum
	common /KTOT/ Knum
c ... /FKS/ 
	logical FakeS
	common /FKS/ FakeS
c ...	comments common
	character*180 comments
	common /CMNTS/ comments
c local
      real cut_point, p_tot, unitarity, p_rest(8)
      integer j
c begin 
      Open ( unit = 22,
     &     file = DirSave(1:DirL)//'run-condition.dat',
     &     status = 'unknown' )
c
	write(22,*) ' ###### reason why I try this simulation condition ###### '
	write(22,*) comments
	write(22,*) 'Save directory =', DirSave(1:DirL)
	write(22,*) 'Total Kaon Number to be generated =', Knum*0.1, ' (M) events'
	write(22,*) ''
	write(22,*) '#### K Nucleus  ------------------------'
	write(22,*) '    branch ', r_knucl,'  Binding energy: ',B_KN,
     &		' MeV        Width ', G_KN,' MeV (FWHM)'
c ... decay_branch
      p_tot = 0.
      do j = 1, 8
         p_tot = p_tot + decay_branch(j)
      EndDo
      do j = 1, 8
         decay_branch(j) = decay_branch(j) / p_tot
      EndDo
	write(22,*) ''
	write(22,*) '# Knucl decay branch was set to -------------------'
	write(22,*)   'reaction  '//' branch '//'  :  '//' SL conv.'
      write(22,*) ' He3K -> L pi- p p    ', decay_branch(1), '  :  ', 0.
	if(FF_knucl_decay) then
         write(22,*) ' He3K -> S0 n p       ', decay_branch(2), '  :  ', SLC_KN_Spn
         write(22,*) ' He3K -> S- p p       ', decay_branch(3), '  :  ', SLC_KN_Spp
         write(22,*) ' He3K -> S+ n n       ', decay_branch(4), '  :  ', SLC_KN_Snn
	else
         write(22,*) ' He3K -> S0 n p       ', decay_branch(2), '  :  ', 0.
         write(22,*) ' He3K -> S- p p       ', decay_branch(3), '  :  ', 0.
         write(22,*) ' He3K -> S+ n n       ', decay_branch(4), '  :  ', 0.
	endif
      write(22,*) ' He3K -> L n p        ', decay_branch(5), '  :  ', 0.
      write(22,*) ' He3K -> L d          ', decay_branch(6), '  :  ', 0.
      write(22,*) ' He3K -> pi0 L p n    ', decay_branch(7), '  :  ', 0.
c      write(22,*) ' TBA                  ', decay_branch(8), 0.
      cut_point = 0.
      do j = 1, 8
         cut_point = cut_point + decay_branch(j) 
         decay_branch(j) = cut_point 
      EndDo
c ... Quasi-free branch
      p_tot = 0.
      do j = 1, 8
         p_tot = p_tot + p_quasi(j)
      EndDo
      do j = 1, 8
	   p_quasi(j)  = p_quasi(j) / p_tot
	   p_rest(j) = 1. 
     &		- ( p_SL_conv(j) + p_Y_scat(j) + p_pi_scat(j) + p_pi_abs(j) ) 
	EndDo
	write(22,*) ''
	write(22,*) '### Quasi-free branch was set to ------------------------'
	write(22,*)   'reaction  '//' branch '//'   '//' SL conv.'//'  Y scat.'
     &			              //' pi scat.'//' pi abs.i'//'  Escape '
  	write(22,101) ' 1) Sigma+ pi- ',p_quasi(1)*100.,' : ',
     &		p_SL_conv(1), p_Y_scat(1), 
     &		p_pi_scat(1), p_pi_abs(1), p_rest(1)
  	write(22,101) ' 2) Sigma- pi+ ',p_quasi(2)*100.,' : ',
     &		p_SL_conv(2), p_Y_scat(2), 
     &		p_pi_scat(2), p_pi_abs(2), p_rest(2)
  	write(22,101) ' 3) Sigma0 pi0 ',p_quasi(3)*100.,' : ',
     &		p_SL_conv(3), p_Y_scat(3), 
     &		p_pi_scat(3), p_pi_abs(3), p_rest(3)
  	write(22,101) ' 4) Sigma- pi0 ',p_quasi(4)*100.,' : ',
     &		p_SL_conv(4), p_Y_scat(4), 
     &		p_pi_scat(4), p_pi_abs(4), p_rest(4)
  	write(22,101) ' 5) Sigma0 pi- ',p_quasi(5)*100.,' : ',
     &		p_SL_conv(5), p_Y_scat(5), 
     &		p_pi_scat(5), p_pi_abs(5), p_rest(5)
  	write(22,101) ' 6) Lambda pi0 ',p_quasi(6)*100.,' : ',
     &		p_SL_conv(6), p_Y_scat(6), 
     &		p_pi_scat(6), p_pi_abs(6), p_rest(6)
  	write(22,101) ' 7) Lambda pi- ',p_quasi(7)*100.,' : ',
     &		p_SL_conv(7), p_Y_scat(7), 
     &		p_pi_scat(7), p_pi_abs(7), p_rest(7)
  	write(22,101) ' 8) Sigma+ pi0 ',p_quasi(8)*100.,' : ',
     &		p_SL_conv(8), p_Y_scat(8), 
     &		p_pi_scat(8), p_pi_abs(8), p_rest(8)
101	format(a, f6.2, a, f9.3, f9.3, f9.3, f9.3, f9.3)
	Do j = 1, 8
	   p_SL_conv(j) = p_SL_conv(j)  
	   p_Y_scat(j) = p_Y_scat(j) 
     &		/ (1. - ( p_SL_conv(j) ) )
	   p_pi_scat(j) = p_pi_scat(j)
     &		/ (1. - ( p_SL_conv(j) + p_Y_scat(j) ) )
	   p_pi_abs(j) = p_pi_abs(j)
     &		/ (1. - ( p_SL_conv(j) + p_Y_scat(j) + p_pi_scat(j) ) )
	EndDo
      cut_point = 0.
      do j = 1, 8
         cut_point = cut_point + p_quasi(j)
         p_quasi(j) = cut_point 
      EndDo
      write(22,*) '# ratio of 1N / 2N reaction for QF reaction'
      write(22,*) '#    primary   :   K + He -> pi + Y + Res.'
	write(22,130) r_1N_2N_S, ' Sigma  quasi_free process'
      write(22,130) r_1N_2N_L, ' Lambda quasi_free process'
      write(22,*) '#    secondary :   Y/pi + Res. -> anything'
      write(22,130) r_1N_2N_SLC, '   Sigma-Lambda conversion'
      write(22,130) r_1N_2N_SNS, '   Sigma-residual scattering'
      write(22,130) r_1N_2N_LNS, '   Lambda-residual scattering'
      write(22,130) r_1N_2N_piS, '   pion scattering (pi induced brackup)'
130	format(f9.3, a)
c ... # K non-mesic absorption
	write(22,*) ''
	write(22,*) '### K Non-mesic absorption branch was set to -------------------'
	write(22,*)   'reaction  '//' branch '//'   '//' SL conv.'//'  Y scat.'
     &			              //'  Escape '
      p_tot = 0.
      do j = 1, 4
         p_tot = p_tot + r_KN_2body(j)
      EndDo
      do j = 1, 4
         r_KN_2body(j) = r_KN_2body(j) / p_tot
      EndDo
      write(22,102) ' 1) L n d   ', r_KN_2body(1)*r_2N_3N_K2NL_pn, ' : ',
     &	p_SL_conv_2N(1), p_Y_scat_2N(1), 1.-p_SL_conv_2N(1)-p_Y_scat_2N(1)
      write(22,102) ' ?) L p n n ', r_KN_2body(1)*(1.-r_2N_3N_K2NL_pn), ' : '
      write(22,102) ' 2) S0 n d  ', r_KN_2body(2), ' : ',
     &	p_SL_conv_2N(2), p_Y_scat_2N(2), 1.-p_SL_conv_2N(2)-p_Y_scat_2N(2)
      write(22,102) ' 3) S- p d  ', r_KN_2body(3), ' : ',
     &	p_SL_conv_2N(3), p_Y_scat_2N(3), 1.-p_SL_conv_2N(3)-p_Y_scat_2N(3)
      write(22,102) ' 4) S+ n n n', r_KN_2body(4), ' : ',
     &	p_SL_conv_2N(4), p_Y_scat_2N(4), 1.-p_SL_conv_2N(4)-p_Y_scat_2N(4)
102	format(a, f6.2, a, f9.3, f9.3, f9.3)
      cut_point = 0.
      do j = 1, 4
         cut_point = cut_point + r_KN_2body(j) 
         r_KN_2body(j) = cut_point 
      EndDo
      do j = 1, 4
         p_Y_scat_2N(j) = p_Y_scat_2N(j) / ( 1. - p_SL_conv_2N(j) )
      EndDo
      write(22,*) '# ratio of 1N(+Y) / 2N(+Y) reaction for KN non-mesic absorption'
      write(22,130) r_2N_3N_K2NS, ' Sigma none-mesic'
      write(22,130) r_2N_3N_K2NL, ' Lambda none-mesic'
c ... # piN 2-nucleon absorption
	write(22,*) '# piN 2-nucleon absorption ---------------------------------'
      write(22,*) '# ratio of 2N / 3N reaction for piN absorption'
      write(22,130) r_2N_3N_piEx_abs, ' pi- He -> nnd / pnnn  '
c
100	format(a, f6.2, a, f9.3, f9.3, f9.3, f9.3)
110	format(a, f9.3, f9.3)
120	format(a, f9.3)
c
      unitarity = r_two_nucl + r_quasi_free
     &            + r_Lambda_Hyper + r_Sigma_Hyper
      r_knucl = r_knucl 
      r_two_nucl = r_two_nucl / unitarity * (1. - r_knucl)
      r_quasi_free = r_quasi_free / unitarity * (1. - r_knucl)
      r_Lambda_Hyper = r_Lambda_Hyper / unitarity * (1. - r_knucl)
      r_Sigma_Hyper = r_Sigma_Hyper / unitarity * (1. - r_knucl)
c
	write(22,*) ''
      write(22,*) '### Hypernuclei'
	write(22,*) 'B_Sp0, G_Sp0, B_L0, G_L0',B_Sp0, G_Sp0, B_L0, G_L0
      write(22,*) ''
      write(22,*) '######## ratio ########'
      write(22,*) ' 123456789 123456789 123456789 123456789 123456789 123456789 123456789'
      write(22,*) '    knucl,     QF-Y, non-mesic,   L_Hyp,     S_Hyp :   total'
      write(22,*) r_knucl, r_quasi_free, r_two_nucl, r_Lambda_Hyper, r_Sigma_Hyper,
     &	r_knucl+r_two_nucl+r_quasi_free+r_Lambda_Hyper+r_Sigma_Hyper
c  
	write(22,*) ''
	write(22,*) ''
	write(22,*) ''
	write(22,*) '###### global simulation condition ######'
	write(22,*) 'NC thickness (cm)', delta_x	
	write(22,*) 'NC position resolution (sigma in cm)', delta_y
	write(22,*) 'T0 counter time resolution (nsec)', delta_T0
	write(22,*) 'neutron counter time resolution (nsec)', delta_NC
	write(22,*) 'TC light-guide acceptance', TC_eff
	write(22,*) 'T0 light-guide acceptance', T0_eff
	write(22,*) 'Coulomb scattering ON(=1)/OFF(=0)', multi_set
	write(22,*) 'kaon decay ON(=1)/OFF(=0)', k_decay_set
	write(22,*) 'T0-time correction ON(=1)/Skip(=0)', Kstop_cor
	write(22,*) 'Apply nuclear formfactor scaled(=2)/ON(=1)/OFF(=0)', FF_knucl_decay
	write(22,*) 'neutron constant background level', CBG_level, ' (relative)'
	write(22,*) 'Nutron production durling pion travel  ', n_prod_dpit, '   : previously = 0.'
	write(22,*) 'VDC threshold  ', VDC_threshold,  ' (MeV)   : previously = 0.'
	write(22,*) 'VDC resolution ', VDC_resolution*10., ' (mm)    : previously = 0.'
	if(FakeS) then 
	   write(22,*) '*** Caution *** Fake simulation without S+/- energy loss is ON (intended!?)'
	endif
	close(22)

	T0_eff = 9. / sqrt(T0_eff)
	TC_eff = 9. / sqrt(TC_eff)
      H3_pim_Sp = 0.
      dn_pim_Sp = 0.
      pnn_pim_Sp = 0.
      nnn_pi0_Sp = 0.
      nnn_Sp = 0.
      tot_Sp = 0.

      H3_pip_Sm = 0.
      dn_pip_Sm = 0.
      pnn_pip_Sm = 0.
      He3_pi0_Sm = 0.
      dp_pi0_Sm = 0.
      ppn_pi0_Sm = 0.
      dp_Sm = 0.
      ppn_Sm = 0.
      tot_Sm = 0.

      He3_pim_L = 0.
      dp_pim_L = 0.
      ppn_pim_L = 0.
      He3_pim_S0 = 0.
      dp_ppn_pim_S0 = 0.
      dn_pnn_pi0_L_S0 = 0.
      dn_pnn_L_S0 = 0.
      nnn_pip_L_S0 = 0.
      tot_L_S0 = 0.

      ext_Sm_conv = 0.
	L_hyp_mesic = 0.
	L_hyp_nmesic = 0.
	L_pi0_t = 0.
	S0_pi0_t = 0.
	
      return
      end   





      subroutine branch_print( ev_number, j2 )
      implicit NONE
      integer ev_number, j2
	real total
c common for branch check
      real H3_pim_Sp, dn_pim_Sp, pnn_pim_Sp, nnn_pi0_Sp, nnn_Sp, tot_Sp
      real H3_pip_Sm, dn_pip_Sm, pnn_pip_Sm, He3_pi0_Sm, dp_pi0_Sm
      real ppn_pi0_Sm, dp_Sm, ppn_Sm, tot_Sm
      real He3_pim_L, dp_pim_L, ppn_pim_L, He3_pim_S0, dp_ppn_pim_S0
      real dn_pnn_pi0_L_S0, dn_pnn_L_S0, nnn_pip_L_S0, tot_L_S0   
      real ext_Sm_conv
      common /branch_check/  H3_pim_Sp, dn_pim_Sp, pnn_pim_Sp
     &      , nnn_pi0_Sp, nnn_Sp, tot_Sp
     &      , H3_pip_Sm, dn_pip_Sm, pnn_pip_Sm, He3_pi0_Sm, dp_pi0_Sm
     &      , ppn_pi0_Sm, dp_Sm, ppn_Sm, tot_Sm
     &      , He3_pim_L, dp_pim_L, ppn_pim_L, He3_pim_S0, dp_ppn_pim_S0
     &      , dn_pnn_pi0_L_S0, dn_pnn_L_S0, nnn_pip_L_S0, tot_L_S0
     &      , ext_Sm_conv
      real L_hyp_mesic, L_pi0_t, S0_pi0_t, L_hyp_nmesic
      common /branch_misc/  L_hyp_mesic, L_pi0_t, S0_pi0_t, L_hyp_nmesic
c ... common /RTS/ for ratios of scaling
	real y_ratio_all, y_ratio_fp, y_ratio_sp
	common /RTS/ y_ratio_all, y_ratio_fp, y_ratio_sp
c ... common /DIRS/ for save directory name
	character*80 DirSave
	integer DirL
	common /DIRS/ DirSave, DirL
c
100	format(a,f5.2,a3,f5.2,a)
c begin
      Open ( unit = 23,
     &     file = DirSave(1:DirL)//'run-branch.dat',
     &     status = 'unknown' )
      tot_Sp = H3_pim_Sp + dn_pim_Sp + pnn_pim_Sp + nnn_pi0_Sp + nnn_Sp
      tot_Sm = H3_pip_Sm + dn_pip_Sm + pnn_pip_Sm + He3_pi0_Sm
     &      + dp_pi0_Sm + ppn_pi0_Sm + dp_Sm + ppn_Sm
      tot_L_S0 = He3_pim_L + dp_pim_L + ppn_pim_L + He3_pim_S0
     &      + dp_ppn_pim_S0 + dn_pnn_pi0_L_S0 + dn_pnn_L_S0 + nnn_pip_L_S0
	total = tot_Sp + tot_Sm + tot_L_S0
	write(23,*) 'Save directory =', DirSave(1:DirL)
	write(23,*) 'Accumulated Kaon ', ev_number/1000000., ' (M) events'
	write(23,*) ''
	total = total/100.
      write(23,100) 'H3 pi- S+            : ', H3_pim_Sp/total, 
     &            ' +- ', sqrt(H3_pim_Sp)/total,'    9.3 +- 2.3'
      write(23,100) 'd n pi- S+           : ', dn_pim_Sp /total,
     &            ' +- ', sqrt(dn_pim_Sp)/total,'    1.9 +- 0.7'
      write(23,100) 'p n n pi- S+         : ', pnn_pim_Sp /total, 
     &            ' +- ', sqrt(pnn_pim_Sp)/total,'    1.6 +- 0.6'
      write(23,100) 'n n n pi0 S+         : ', nnn_pi0_Sp /total, 
     &            ' +- ', sqrt(nnn_pi0_Sp)/total,'    3.2 +- 1.0'
      write(23,100) 'n n n S+             : ', nnn_Sp /total, 
     &            ' +- ', sqrt(nnn_Sp)/total,'    1.0 +- 0.4'
      write(23,*) '       ......................'
      write(23,100) 'total S+             : ', tot_Sp /total, 
     &            ' +- ', sqrt(tot_Sp)/total,'   17.0 +- 2.7'
      write(23,*) ' '
      write(23,100) 'H3 pi+ S-            : ', H3_pip_Sm /total, 
     &            ' +- ', sqrt(H3_pip_Sm)/total,'    4.2 +- 1.2'
      write(23,100) 'd n pi+ S-           : ', dn_pip_Sm /total, 
     &            ' +- ', sqrt(dn_pip_Sm)/total,'    1.6 +- 0.6'
      write(23,100) 'p n n pi+ S-         : ', pnn_pip_Sm /total, 
     &            ' +- ', sqrt(pnn_pip_Sm)/total,'    1.4 +- 0.5'
      write(23,100) 'He3 pi0 S-           : ', He3_pi0_Sm /total, 
     &            ' +- ', sqrt(He3_pi0_Sm)/total,'    1.0 +- 0.5'
      write(23,100) 'd p pi0 S-           : ', dp_pi0_Sm /total, 
     &            ' +- ', sqrt(dp_pi0_Sm)/total,'    1.0 +- 0.5'
      write(23,100) 'p p n pi0 S-         : ', ppn_pi0_Sm /total, 
     &            ' +- ', sqrt(ppn_pi0_Sm)/total,'    1.0 +- 0.4'
      write(23,100) 'd p S-               : ', dp_Sm /total, 
     &            ' +- ', sqrt(dp_Sm)/total,'    1.6 +- 0.6'
      write(23,100) 'p p n S-             : ', ppn_Sm /total, 
     &            ' +- ', sqrt(ppn_Sm)/total,'    2.0 +- 0.7'
      write(23,*) '       ......................'
      write(23,100) 'total S-             : ', tot_Sm /total, 
     &            ' +- ', sqrt(tot_Sm)/total,'   13.8 +- 1.8'
      write(23,*) ' '
      write(23,100) 'He3 pi- L            : ', He3_pim_L /total, 
     &            ' +- ', sqrt(He3_pim_L)/total,'   11.2 +- 2.7'
      write(23,100) 'd p pi- L            : ', dp_pim_L /total, 
     &            ' +- ', sqrt(dp_pim_L)/total,'   10.9 +- 2.6'
      write(23,100) 'p p n pi- L          : ', ppn_pim_L /total, 
     &            ' +- ', sqrt(ppn_pim_L)/total,'    9.5 +- 2.4'
      write(23,100) 'He3 pi- S0           : ', He3_pim_S0 /total, 
     &            ' +- ', sqrt(He3_pim_S0)/total,'    0.9 +- 0.6'
      write(23,100) 'd p (ppn) pi- S0     : ', dp_ppn_pim_S0 /total, 
     &            ' +- ', sqrt(dp_ppn_pim_S0)/total,'    0.3 +- 0.3'
      write(23,100) 'd n (pnn) pi0 L (S0) : ', dn_pnn_pi0_L_S0 /total, 
     &            ' +- ', sqrt(dn_pnn_pi0_L_S0)/total,'   22.5 +- 4.2'
      write(23,100) 'd n (pnn) L (S0)     : ', dn_pnn_L_S0 /total, 
     &            ' +- ', sqrt(dn_pnn_L_S0)/total,'   11.7 +- 2.4'
      write(23,100) 'n n n pi+ L (S0)     : ', nnn_pip_L_S0 /total, 
     &            ' +- ', sqrt(nnn_pip_L_S0)/total,'    2.1 +- 0.7'
      write(23,*) '       ......................'
      write(23,100) 'total L (S0)         : ', tot_L_S0 /total, 
     &            ' +- ', sqrt(tot_L_S0)/total,'   69.2 +- 6.6'
      write(23,*) ' '
      write(23,100) 'extarnal S- conv.    : ', ext_Sm_conv 
     &            /total, ' +- ', sqrt(ext_Sm_conv)/total,'   not available'
      write(23,*) '  --- miscs ---------------------------------'
      write(23,100) 'L_hyper  mesic       : ', L_hyp_mesic
     &            /total, ' +- ', sqrt(L_hyp_mesic)/total,'   not available'
      write(23,100) 'L_hyper  none-mesic  : ', L_hyp_nmesic
     &            /total, ' +- ', sqrt(L_hyp_nmesic)/total,'   not available'
      write(23,100) 'S0_pi0_t             : ', L_pi0_t
     &            /total, ' +- ', sqrt(L_pi0_t)/total,'   not available'
      write(23,100) 'S0_pi0_t             : ', L_pi0_t
     &            /total, ' +- ', sqrt(L_pi0_t)/total,'   not available'
      write(23,*) '  -----------------------------------------'
      write(23,*) ''
      write(23,*) ''
      write(23,*) ''
c ... common /RTS/ for ratios of scaling
      write(23,*) '  scaling factors applied to simulation for the comparison with data'
      write(23,*) y_ratio_all, y_ratio_fp, y_ratio_sp
	close(23)
      return
      end



