c ... common /RIDS/ reaction ID
c
c All		All with KN	  	:  - (with KN)	p1 : black
c KN		KN reaction  	:  1 (formation)	p1 : black
c tnL		none-mesic Lmbda	:  2 (reaction)	p1 : yellow
c tnS		none-mesic Sigma	:  3 (reaction)	p1 : blue
c pi_abs	pion absorption	:  4 (internal)	p1 : cyan
c SLC		Sigma-Lmbda conv 	:  5 (reaction)	p1 : green
c QFL		QF (mesic) Lmbda	:  6 (reaction)	p1 : magenta
c QFS		QF (mesic) Sigma	:  7 (reaction)	p1 : red
c CBG		const. background	:  8 (accidental)	p1 : blue
c
c -All	All without KN  	:  - (without KN)	p2 : black
c -KN		KN reaction		: -1 (KN decay)	p2 : black
c -tnL	none-mesic Lmbda	: -2 (L decay)	p2 : yellow
c -tnS	none-mesic Sigma	: -3 (S decay)	p2 : blue
c -pI_abs	pion absorption	: -4 (external)	p2 : cyan
c -SLC	igma-Lmbda conv	: -5 (L decay)	p2 : green
c -QFL	QF (mesic) Lmbda	: -6 (L decay)	p2 : magenta
c -QFS	QF (mesic) Sigma	: -7 (S decay)	p2 : red
c -pI_mono	pion abs mono	: -8 (external)	p2 : blue
c

      subroutine K_3He_nuclei
      implicit NONE
C K-NUCLEUS PRODUCTION
c local variables
      real M_knucl, p_knucl, v_knucl(3), p_n, v_n(3), p_L, v_L(3), p_pi0, v_pi0(3)
      real p_deuteron, v_deuteron(3), p_S0, v_S0(3), p_p, v_p(3), p_n2, v_n2(3)
      real p_Sm, v_Sm(3), p_p2, v_p2(3), p_n3, v_n3(3), p_Sp, v_Sp(3)
      real p_pim, v_pim, M_tot, r
      real point(3), time
      integer iflag
c ... common /masses/
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common /kaon/ for kaon trajectory
      real  kaon_point(3) ! position of the K-reaction
      real  kt_vector(3) ! trajectory of the kaon injection
      real  kt_point(3) ! position of the K-reaction
      real  K_stop_time, K_flight_time, dL_T0
      common /kaon/ kaon_point, kt_point, kt_vector, K_stop_time, K_flight_time, dL_T0
c ... common for binding enery
	real B_KN, G_KN
	common /K_Nucl/ B_KN, G_KN
c ... common for KN_decay
	real decay_branch(8)
	common /KN_decay/ decay_branch(8)
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c ... common /setup/ for simulation run-condition, counter resolution and its efficiency
	integer FF_knucl_decay, multi_set, k_decay_set
	logical Kstop_cor
      real  delta_x, delta_y, delta_T0, delta_NC, TC_eff, T0_eff
      common /setup/ delta_x, delta_y, delta_T0, delta_NC, TC_eff, T0_eff,
     &	FF_knucl_decay, multi_set, k_decay_set, Kstop_cor
c common /F_KN/ for knucl Fermi-motion enlaging factor and SL conversion
	logical Fermi_Knucl
	real SLC_KN_Spp, SLC_KN_Spn, SLC_KN_Snn
	common /F_KN/ Fermi_Knucl, SLC_KN_Spp, SLC_KN_Spn, SLC_KN_Snn
c external
	real rn, Lorentz_FWHM
c added local
	integer N_nucl, N_Pickup, icode
	real M_0, p_0, v_0(3)
c begin
c ... K helium 3 nuclei production
	time  = K_stop_time
      point(1) =  kaon_point(1)
      point(2) =  kaon_point(2)
      point(3) =  kaon_point(3)
10	M_knucl = M_helium3 + M_K - Lorentz_FWHM(B_KN, G_KN)
c
      M_tot = M_k + M_helium4
      iflag = -1
      call decay_2_at_rest( M_tot, 
     &      M_n, M_knucl, p_n, p_knucl, v_n, v_knucl, iflag )
	if(iflag .eq. 1) go to 10
         r = rn()
	   M_0 = 0.
	   p_0 = 0.
	   v_0(1) = 0.
	   v_0(2) = 0.
	   v_0(3) = 1.
	if(FF_knucl_decay .ge. 1) then
c ... decay of K - Helium3 nuclei 
c At the moment, K-nucleus decay only to 
         if(r.lt.decay_branch(1)) then
c    Lambda pi^- p p   
            N_nucl = 3
            N_pickup = 2
            iflag = -1
		if(FF_knucl_decay .eq. 2) Fermi_Knucl = .true.
            call reaction_in_flight_4(
     &		M_knucl, p_knucl, v_knucl, M_0, p_0, v_0,
     &            M_L, M_pi, M_p,  M_p, 
     &            p_L, p_pim, p_p2, p_p, 
     &            v_L, v_pim, v_p2, v_p, 
     &		N_nucl, N_pickup, iflag)
		Fermi_Knucl = .false.
            if(iflag .eq. 0) then
      	   call put_stack(PID_neutron, p_n, v_n, point, time, KN)
      	   call put_stack(PID_proton, p_p, v_p, point, time, -KN)
      	   call put_stack(PID_proton, p_p2, v_p2, point, time, -KN)
               call put_stack(-PID_pion, p_pim, v_pim,  point, time, -KN)
      	   call put_stack(PID_Lambda, p_L, v_L, point, time, -KN)
               return
	      else
		   go to 10
            endif
         else if(r.lt.decay_branch(2)) then
c    Sigma0 n p      
            N_nucl = 3
            N_pickup = 2
            iflag = -1
		if(FF_knucl_decay .eq. 2) Fermi_Knucl = .true.
	      if(rn() .lt. 0.5) then
		   icode = 1
               call reaction_in_flight_3( 
     &		M_knucl, p_knucl, v_knucl, M_0, p_0, v_0,
     &            M_S0, M_n, M_p, 
     &            p_S0, p_n2, p_p, 
     &            v_S0, v_n2, v_p, N_nucl, N_pickup, iflag )
	      else
		   icode = 2
               call reaction_in_flight_3( 
     &		M_knucl, p_knucl, v_knucl, M_0, p_0, v_0,
     &            M_S0, M_p, M_n, 
     &            p_S0, p_p, p_n2, 
     &            v_S0, v_p, v_n2, N_nucl, N_pickup, iflag )
	      endif
		Fermi_Knucl = .false.
            if(iflag .eq. 0) then
      	   call put_stack(PID_neutron, p_n, v_n, point, time, KN)
		   if( rn() .lt. SLC_KN_Spn ) then
			iflag = 0
		      if( icode .eq. 1 ) then
                     call reaction_in_flight_2( 
     &			M_S0, p_S0, v_S0, M_p, p_p, v_p, 
     &            	M_L, M_p, 
     &            	p_L, p_p, 
     &            	v_L, v_p, iflag )
		      else
                     call reaction_in_flight_2( 
     &			M_S0, p_S0, v_S0, M_n, p_n2, v_n2, 
     &            	M_L, M_n, 
     &            	p_L, p_n2, 
     &            	v_L, v_n2, iflag )
		      endif
      	      call put_stack(PID_Lambda, p_L, v_L, point, time, -KN)
      	      call put_stack(PID_proton, p_p, v_p, point, time, -KN)
      	      call put_stack(PID_neutron, p_n2, v_n2, point, time, -KN)
		   else  
      	      call put_stack(PID_neutron, p_n2, v_n2, point, time, -KN)
      	      call put_stack(PID_proton, p_p, v_p, point, time, -KN)
      	      call put_stack(PID_Sigma0, p_S0, v_S0, point, time, -KN)
		   endif
               return
	      else
		   go to 10
            endif
         else if(r.lt.decay_branch(3)) then
c    Sigmam p p      
            N_nucl = 3
            N_pickup = 2
            iflag = -1
		if(FF_knucl_decay .eq. 2) Fermi_Knucl = .true.
            call reaction_in_flight_3( 
     &		M_knucl, p_knucl, v_knucl, M_0, p_0, v_0,
     &            M_Sm, M_p, M_p, 
     &            p_Sm, p_p2, p_p, 
     &            v_Sm, v_p2, v_p, N_nucl, N_pickup, iflag )
		Fermi_Knucl = .false.
            if(iflag .eq. 0) then
      	   call put_stack(PID_neutron, p_n, v_n, point, time, KN)
      	   call put_stack(PID_proton, p_p2, v_p2, point, time, -KN)
		   if( rn() .lt. SLC_KN_Spp ) then
			iflag = 0
                  call reaction_in_flight_2( 
     &			M_Sm, p_Sm, v_Sm, M_p, p_p, v_p, 
     &            	M_L, M_n, 
     &            	p_L, p_n2, 
     &            	v_L, v_n2, iflag )
      	      call put_stack(PID_Lambda, p_L, v_L, point, time, -KN)
      	      call put_stack(PID_neutron, p_n2, v_n2, point, time, -KN)
		   else  
      	      call put_stack(PID_proton, p_p, v_p, point, time, -KN)
      	      call put_stack(PID_SigmaM, p_Sm, v_Sm, point, time, -KN)
		   endif
               return
	      else
		   go to 10
            endif
         else if(r.lt.decay_branch(4)) then
c    Sigma+ n n      
            N_nucl = 3
            N_pickup = 2
            iflag = -1
		if(FF_knucl_decay .eq. 2) Fermi_Knucl = .true.
            call reaction_in_flight_3( 
     &		M_knucl, p_knucl, v_knucl, M_0, p_0, v_0,
     &            M_Sp, M_n, M_n, 
     &            p_Sp, p_n2, p_n3, 
     &            v_Sp, v_n2, v_n3, N_nucl, N_pickup, iflag )
		Fermi_Knucl = .false.
            if(iflag .eq. 0) then
      	   call put_stack(PID_neutron, p_n, v_n, point, time, KN)
      	   call put_stack(PID_neutron, p_n2, v_n2, point, time, -KN)
		   if( rn() .lt. SLC_KN_Snn ) then
			iflag = 0
                  call reaction_in_flight_2( 
     &			M_Sp, p_Sp, v_Sp, M_n, p_n3, v_n3, 
     &            	M_L, M_p, 
     &            	p_L, p_p, 
     &            	v_L, v_p, iflag )
      	      call put_stack(PID_Lambda, p_L, v_L, point, time, -KN)
      	      call put_stack(PID_proton, p_p, v_p, point, time, -KN)
		   else  
      	      call put_stack(PID_neutron, p_n3, v_n3, point, time, -KN)
      	      call put_stack(PID_SigmaP, p_Sp, v_Sp, point, time, -KN)
		   endif
               return
	      else
		   go to 10
            endif
         else if(r.lt.decay_branch(5)) then
c    Lambda n p      
            iflag = -1
            N_nucl = 3
            N_pickup = 2
            iflag = -1
		if(FF_knucl_decay .eq. 2) Fermi_Knucl = .true.
	      if(rn() .lt. 0.70) then
               call reaction_in_flight_3(
     &		M_knucl, p_knucl, v_knucl, M_0, p_0, v_0,
     &            M_L, M_n, M_p, 
     &            p_L, p_n2, p_p, 
     &            v_L, v_n2, v_p, N_nucl, N_pickup, iflag )
	      else
               call reaction_in_flight_3(
     &		M_knucl, p_knucl, v_knucl, M_0, p_0, v_0,
     &            M_L, M_p, M_n, 
     &            p_L, p_p, p_n2, 
     &            v_L, v_p, v_n2, N_nucl, N_pickup, iflag )
	      endif
		Fermi_Knucl = .false.
            if(iflag .eq. 0) then
      	   call put_stack(PID_neutron, p_n, v_n, point, time, KN)
     		   call put_stack(PID_proton, p_p, v_p, point, time, -KN)
      	   call put_stack(PID_neutron, p_n2, v_n2, point, time, -KN)
      	   call put_stack(PID_Lambda, p_L, v_L, point, time, -KN)
               return
            else
	         go to 10
            endif
         else if(r.lt.decay_branch(6)) then
c    Lambda d        
            iflag = -1
            call decay_2_in_flight( M_knucl, p_knucl, v_knucl, 
     &            M_L, M_deuteron, 
     &            p_L, p_deuteron, 
     &            v_L, v_deuteron, iflag )
            if(iflag .eq. 0) then
      	   call put_stack(PID_neutron, p_n, v_n, point, time, KN)
      	   call put_stack(PID_Lambda, p_L, v_L, point, time, -KN)
      	   call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, -KN)
               return
            else
	         go to 10
            endif
         else if(r.lt.decay_branch(7)) then
c    pi0 Lambda p n        
           iflag = -1
           N_nucl = 3
           N_pickup = 1
           call breakup_in_flight_4(M_knucl, p_knucl, v_knucl, M_0, p_0, v_0, 
     &               M_L, M_pi0, M_p, M_n,  
     &               p_L, p_pi0, p_p, p_n2, 
     &               v_L, v_pi0, v_p, v_n2, N_nucl, N_pickup, iflag )
            if(iflag .eq. 0) then
               call put_stack(PID_neutron, p_n, v_n, point, time, KN)
      	   call put_stack(PID_Lambda, p_L, v_L, point, time, -KN)
      	   call put_stack(PID_proton, p_p, v_p, point, time, -KN)
      	   call put_stack(PID_neutron, p_n2, v_n2, point, time, -KN)
      	   call put_stack(PID_pi0, p_pi0, v_pi0, point, time, -KN)
               return
            else
	         go to 10
            endif
         else
	      go to 10
         endif
	else
c ... decay of K - Helium3 nuclei 
c At the moment, K-nucleus decay only to 
         if(r.lt.decay_branch(1)) then
c    Lambda pi^- p p   
            iflag = -1
            call decay_4_in_flight(
     &		M_knucl, p_knucl, v_knucl, 
     &            M_L, M_pi, M_p,  M_p, 
     &            p_L, p_pim, p_p2, p_p, 
     &            v_L, v_pim, v_p2, v_p, iflag)
            if(iflag .eq. 0) then
      	   call put_stack(PID_neutron, p_n, v_n, point, time, KN)
      	   call put_stack(PID_proton, p_p, v_p, point, time, -KN)
      	   call put_stack(PID_proton, p_p2, v_p2, point, time, -KN)
               call put_stack(-PID_pion, p_pim, v_pim,  point, time, -KN)
      	   call put_stack(PID_Lambda, p_L, v_L, point, time, -KN)
               return
	      else
		   go to 10
            endif
         else if(r.lt.decay_branch(2)) then
c    Sigma0 n p      
            iflag = -1
            call decay_3_in_flight( 
     &		M_knucl, p_knucl, v_knucl, 
     &            M_S0, M_n, M_p, 
     &            p_S0, p_n2, p_p, 
     &            v_S0, v_n2, v_p, iflag )
            if(iflag .eq. 0) then
      	   call put_stack(PID_neutron, p_n, v_n, point, time, KN)
      	   call put_stack(PID_proton, p_p, v_p, point, time, -KN)
      	   call put_stack(PID_neutron, p_n2, v_n2, point, time, -KN)
      	   call put_stack(PID_Sigma0, p_S0, v_S0, point, time, -KN)
               return
	      else
		   go to 10
            endif
         else if(r.lt.decay_branch(3)) then
c    Sigmam p p      
            iflag = -1
            call decay_3_in_flight( 
     &		M_knucl, p_knucl, v_knucl, 
     &            M_Sm, M_p, M_p, 
     &            p_Sm, p_p2, p_p, 
     &            v_Sm, v_p2, v_p, iflag )
            if(iflag .eq. 0) then
      	   call put_stack(PID_neutron, p_n, v_n, point, time, KN)
      	   call put_stack(PID_proton, p_p, v_p, point, time, -KN)
      	   call put_stack(PID_proton, p_p2, v_p2, point, time, -KN)
      	   call put_stack(PID_SigmaM, p_Sm, v_Sm, point, time, -KN)
               return
	      else
		   go to 10
            endif
         else if(r.lt.decay_branch(4)) then
c    Sigma+ n n      
            iflag = -1
            call decay_3_in_flight( 
     &		M_knucl, p_knucl, v_knucl, 
     &            M_Sp, M_n, M_n, 
     &            p_Sp, p_n2, p_n3, 
     &            v_Sp, v_n2, v_n3, iflag )
            if(iflag .eq. 0) then
      	   call put_stack(PID_neutron, p_n, v_n, point, time, KN)
      	   call put_stack(PID_neutron, p_n2, v_n2, point, time, -KN)
      	   call put_stack(PID_neutron, p_n3, v_n3, point, time, -KN)
      	   call put_stack(PID_SigmaP, p_Sp, v_Sp, point, time, -KN)
               return
	      else
		   go to 10
            endif
         else if(r.lt.decay_branch(5)) then
c    Lambda n p      
            iflag = -1
            call decay_3_in_flight(
     &		M_knucl, p_knucl, v_knucl, 
     &            M_L, M_n, M_p, 
     &            p_L, p_n2, p_p, 
     &            v_L, v_n2, v_p, iflag )
            if(iflag .eq. 0) then
      	   call put_stack(PID_neutron, p_n, v_n, point, time, KN)
     		   call put_stack(PID_proton, p_p, v_p, point, time, -KN)
      	   call put_stack(PID_neutron, p_n2, v_n2, point, time, -KN)
      	   call put_stack(PID_Lambda, p_L, v_L, point, time, -KN)
               return
            else
	         go to 10
            endif
         else if(r.lt.decay_branch(6)) then
c    Lambda d        
            iflag = -1
            call decay_2_in_flight( M_knucl, p_knucl, v_knucl, 
     &            M_L, M_deuteron, 
     &            p_L, p_deuteron, 
     &            v_L, v_deuteron, iflag )
            if(iflag .eq. 0) then
      	   call put_stack(PID_neutron, p_n, v_n, point, time, KN)
      	   call put_stack(PID_Lambda, p_L, v_L, point, time, -KN)
      	   call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, -KN)
               return
            else
	         go to 10
            endif
         else if(r.lt.decay_branch(7)) then
c    pi0 Lambda p n        
           iflag = -1
           call decay_4_in_flight(M_knucl, p_knucl, v_knucl, 
     &               M_L, M_pi0, M_p, M_n,  
     &               p_L, p_pi0, p_p, p_n2, 
     &               v_L, v_pi0, v_p, v_n2, iflag )
            if(iflag .eq. 0) then
               call put_stack(PID_neutron, p_n, v_n, point, time, KN)
      	   call put_stack(PID_Lambda, p_L, v_L, point, time, -KN)
      	   call put_stack(PID_proton, p_p, v_p, point, time, -KN)
      	   call put_stack(PID_neutron, p_n2, v_n2, point, time, -KN)
      	   call put_stack(PID_pi0, p_pi0, v_pi0, point, time, -KN)
               return
            else
	         go to 10
            endif
         else
	      go to 10
         endif
	endif
      return
      end



      subroutine Lambda_Hyper_nuclei
      implicit NONE
C K-NUCLEUS PRODUCTION
c common
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common /kaon/ for kaon trajectory
      real  kaon_point(3) ! position of the K-reaction
      real  kt_vector(3) ! trajectory of the kaon injection
      real  kt_point(3) ! position of the K-reaction
      real  K_stop_time, K_flight_time, dL_T0
      common /kaon/ kaon_point, kt_point, kt_vector, K_stop_time, K_flight_time, dL_T0
c ... common for hypernuclei
	real B_Sp0, G_Sp0, B_L0, G_L0
	common /HyperBND/ B_Sp0, G_Sp0, B_L0, G_L0
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c external
      real rn, Gauss_FWHM
c local variables
      real p_p, v_p(3), p_pi, v_pi(3), p_pi0, v_pi0(3)
      real M_Lnucl, p_Lnucl, v_Lnucl(3), p_n, v_n(3)
      real M_0, p_0, v_0(3)
      real B_L, M_tot, point(3), time
      integer N_nucl, N_pickup, iflag
	real p_n1, v_n1(3), p_n2, v_n2(3)
	real p_deuteron, v_deuteron(3), p_helium4, v_helium4(3)
	integer PID_helium4 /17/
c begin
      time  = K_stop_time
c ... K helium 3 nuclei production
      point(1) =  kaon_point(1)
      point(2) =  kaon_point(2)
      point(3) =  kaon_point(3)
      B_L = Gauss_FWHM(B_L0, G_L0)
c	write(*,*) 'B_L0, G_L0', B_L0, G_L0, B_L
10    M_Lnucl = M_helium3 + M_L - B_L
         M_tot = M_k + M_helium4
         iflag = 0
         call decay_2_at_rest( M_tot, 
     &      M_pi, M_Lnucl, p_pi, p_Lnucl, v_pi, v_Lnucl, iflag )
	if(iflag .ne. 0) go to 10
      call put_stack(-PID_pion, p_pi, v_pi, point, time, QFL)
c free decay
	M_0 = 0.
	p_0 = 0.
	v_0(1) = 0.
	v_0(2) = 0.
	v_0(3) = 1.
      N_nucl = 4
	iflag = 0
c mesonic decay 
      if(rn() .le. 0.7) then
         N_pickup = 1
         if(rn() .le. 0.358) then
c    ... L -> n + pi0 decay
      	call decay_2_in_flight( M_Lnucl, p_Lnucl, v_Lnucl, 
     &		M_pi0, M_helium4, p_pi0, p_helium4, v_pi0, v_helium4, iflag )
            call put_stack(PID_pi0, p_pi0, v_pi0, point, time, QFL)
            call put_stack(PID_helium4, p_helium4, v_helium4, point, time, QFL)
         else
c    ... L -> p + pi- decay (actually should be Lithium4 and not helium4)
      	call decay_2_in_flight( M_Lnucl, p_Lnucl, v_Lnucl, 
     &		M_pi, M_helium4, p_pi, p_helium4, v_pi, v_helium4, iflag )
            call put_stack(-PID_pion, p_pi, v_pi, point, time, QFL)
            call put_stack(PID_helium4, p_helium4, v_helium4, point, time, QFL)
         endif
c none-mesonic decay 
      else
         if(rn() .le. 0.333) then
c    ... L n -> n n decay
            if(rn() .le. 0.5) then
               N_pickup = 2
               call reaction_in_flight_3( 
     &		M_Lnucl, p_Lnucl, v_Lnucl, M_0, p_0, v_0,
     &            M_n, M_n,  M_deuteron,
     &		p_n, p_n1, p_deuteron,
     &		v_n, v_n1, v_deuteron, N_nucl, N_pickup, iflag )
               call put_stack(PID_neutron, p_n, v_n, point, time, QFL)
               call put_stack(PID_neutron, p_n1, v_n1, point, time, QFL)
               call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, QFL)
            else
               N_pickup = 3
               if(rn() .le. 0.5) then
                call reaction_in_flight_4( 
     &		M_Lnucl, p_Lnucl, v_Lnucl, M_0, p_0, v_0,
     &            M_n, M_n,  M_n,  M_p, 
     &		p_n, p_n1, p_n2, p_p, 
     &		v_n, v_n1, v_n2, v_p, N_nucl, N_pickup, iflag )
               else
                call reaction_in_flight_4( 
     &		M_Lnucl, p_Lnucl, v_Lnucl, M_0, p_0, v_0,
     &            M_n, M_n,  M_p, M_n,  
     &		p_n, p_n1, p_p, p_n2, 
     &		v_n, v_n1, v_p, v_n2, N_nucl, N_pickup, iflag )
               endif
               call put_stack(PID_neutron, p_n, v_n, point, time, QFL)
               call put_stack(PID_neutron, p_n1, v_n1, point, time, QFL)
               call put_stack(PID_neutron, p_n2, v_n2, point, time, QFL)
               call put_stack(PID_proton, p_p, v_p, point, time, QFL)
            endif
         else
c    ... L p -> n p decay
           if(rn() .le. 0.5) then
            N_pickup = 2
            call breakup_in_flight_4( 
     &		M_Lnucl, p_Lnucl, v_Lnucl, M_0, p_0, v_0,
     &            M_p, M_n, M_n,  M_n, 
     &		p_p, p_n, p_n1, p_n2,
     &		v_p, v_n, v_n1, v_n2, N_nucl, N_pickup, iflag )
	     else
            N_pickup = 3
            call reaction_in_flight_4( 
     &		M_Lnucl, p_Lnucl, v_Lnucl, M_0, p_0, v_0,
     &            M_p, M_n, M_n,  M_n, 
     &		p_p, p_n, p_n1, p_n2,
     &		v_p, v_n, v_n1, v_n2, N_nucl, N_pickup, iflag )
	     endif
            call put_stack(PID_neutron, p_n, v_n, point, time, QFL)
            call put_stack(PID_neutron, p_n1, v_n1, point, time, QFL)
            call put_stack(PID_neutron, p_n2, v_n2, point, time, QFL)
            call put_stack(PID_proton, p_p, v_p, point, time, QFL)
         endif
      endif
      return
      end
 


      subroutine Sigmap_Hyper_nuclei
      implicit NONE
C K-NUCLEUS PRODUCTION
c common
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common /kaon/ for kaon trajectory
      real  kaon_point(3) ! position of the K-reaction
      real  kt_vector(3) ! trajectory of the kaon injection
      real  kt_point(3) ! position of the K-reaction
      real  K_stop_time, K_flight_time, dL_T0
      common /kaon/ kaon_point, kt_point, kt_vector, K_stop_time, K_flight_time, dL_T0
c ... common /branch_1N_2N/ for single nucleon reaction ratio
	real  r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_2N_3N_piEx_abs
	common /branch_1N_2N/ r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_2N_3N_K2NS, r_2N_3N_K2NL, r_2N_3N_piEx_abs
c common for branch
	real B_Sp0, G_Sp0, B_L0, G_L0
	common /HyperBND/ B_Sp0, G_Sp0, B_L0, G_L0
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c common for debug
	logical debug_F
      integer ev_NUM, ev_error
      common /DeBugging/ debug_F, ev_NUM, ev_error
c external
      real rn, Lorentz_FWHM
c local variables
      real p_L, v_L(3), p_p1, v_p1(3), p_p2, v_p2(3)
      real M_Spnucl, p_Spnucl, v_Spnucl(3)
      real p_pi, v_pi(3), p_n1, v_n1(3)
      real p_deuteron, v_deuteron(3)
      real M_tot, M_0, p_0, v_0(3)
      real point(3), time, B_Sp
      integer N_nucl, N_pickup, iflag
c begin
      time  = K_stop_time
c ... K helium 3 nuclei production
      point(1) =  kaon_point(1)
      point(2) =  kaon_point(2)
      point(3) =  kaon_point(3)
10    B_Sp = Lorentz_FWHM(B_Sp0, G_Sp0)
	if(B_Sp .lt. 0. .and. rn() .gt. exp(B_Sp/G_Sp0) ) go to 10
        M_Spnucl = M_triton + M_Sp - B_Sp
        M_tot = M_k + M_helium4
        iflag = -1
        call decay_2_at_rest( M_tot, 
     &      M_pi, M_Spnucl, p_pi, p_Spnucl, v_pi, v_Spnucl, iflag )
	if(iflag .eq.1) go to 10
c ... internal conversion of Sigma+
	M_0 = 0.
	p_0 = 0.
	v_0(1) = 0.
	v_0(2) = 0.
	v_0(3) = 1.
      N_nucl = 4
      N_pickup = 2
      iflag = -1
      if( rn() .lt. r_1N_2N_SLC ) then 
c ... t S+ -> d p L
               call reaction_in_flight_3(
     &            M_Spnucl, p_Spnucl, v_Spnucl, M_0, p_0, v_0,
     &            M_L, M_p,  M_deuteron, 
     &            p_L, p_p1, p_deuteron,
     &            v_L, v_p1, v_deuteron, N_nucl, N_pickup, iflag )
 	   if(iflag .eq.1) go to 10
c>>			if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'PID, reactionID =', PID_proton, SLC
    	   call put_stack(PID_proton, p_p1, v_p1, point, time, SLC)
c>>			if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'PID, reactionID =', PID_deuteron, SLC
    	   call put_stack(PID_deuteron, p_deuteron, v_deuteron, point, time, SLC)
      else
c ... t S+ -> p p n L 
               call breakup_in_flight_4(
     &            M_Spnucl, p_Spnucl, v_Spnucl, M_0, p_0, v_0,
     &            M_p,  M_L, M_p,  M_n, 
     &            p_p1, p_L, p_p2, p_n1, 
     &            v_p1, v_L, v_p2, v_n1, N_nucl, N_pickup, iflag )
 	   if(iflag .eq.1) go to 10
c>>			if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'PID, reactionID =', PID_proton, SLC
      	   call put_stack(PID_proton, p_p1, v_p1, point, time, SLC)
c>>			if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'PID, reactionID =', PID_proton, SLC
      	   call put_stack(PID_proton, p_p2, v_p2, point, time, SLC)
c>>			if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'PID, reactionID =', PID_neutron, SLC
               call put_stack(PID_neutron, p_n1, v_n1, point, time, SLC)
      endif
c>>			if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'PID, reactionID =', -PID_pion, QFS
      call put_stack(-PID_pion, p_pi, v_pi, point, time, QFS)
c>>			if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'PID, reactionID =', PID_Lambda, SLC
      call put_stack(PID_Lambda, p_L, v_L, point, time, SLC)
      return
      end





      subroutine KHe_Lt
      implicit NONE
c common
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common /kaon/ for kaon trajectory
      real  kaon_point(3) ! position of the K-reaction
      real  kt_vector(3) ! trajectory of the kaon injection
      real  kt_point(3) ! position of the K-reaction
      real  K_stop_time, K_flight_time, dL_T0
      common /kaon/ kaon_point, kt_point, kt_vector, K_stop_time, K_flight_time, dL_T0
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c local variables
      real p_L, v_L(3)
      real M_tot, p_triton, v_triton(3)
      real point(3), time
      integer iflag
c begin
      time  = K_stop_time
c ... K helium 3 nuclei production
      point(1) =  kaon_point(1)
      point(2) =  kaon_point(2)
      point(3) =  kaon_point(3)
        M_tot = M_k + M_helium4
        iflag = -1
        call decay_2_at_rest( M_tot, 
     &      M_L, M_triton, p_L, p_triton, v_L, v_triton, iflag )
      call put_stack(PID_triton, p_triton, v_triton, point, time, tnL)
      call put_stack(PID_Lambda, p_L, v_L, point, time, tnL)
      return
      end



