c knucl_reaction.f
c ... common /RIDS/ reaction ID
c
c All		All with KN	  	:  - (with KN)	p1 : black
c KN		KN reaction  	:  1 (formation)	p1 : black
c tnL		none-mesic Lmbda	:  2 (reaction)	p1 : yellow
c tnS		none-mesic Sigma	:  3 (reaction)	p1 : blue
c pi_abs	pion absorption	:  4 (internal)	p1 : cyan
c SLC		Sigma-Lmbda conv 	:  5 (reaction)	p1 : green
c QFL		QF (mesic) Lmbda	:  6 (reaction)	p1 : magenta
c QFS		QF (mesic) Sigma	:  7 (reaction)	p1 : red
c CBG		const. background	:  8 (accidental)	p1 : blue
c
c -All	All without KN  	:  - (without KN)	p2 : black
c -KN		KN reaction		: -1 (KN decay)	p2 : black
c -tnL	none-mesic Lmbda	: -2 (L decay)	p2 : yellow
c -tnS	none-mesic Sigma	: -3 (S decay)	p2 : blue
c -pI_abs	pion absorption	: -4 (external)	p2 : cyan
c -SLC	igma-Lmbda conv	: -5 (L decay)	p2 : green
c -QFL	QF (mesic) Lmbda	: -6 (L decay)	p2 : magenta
c -QFS	QF (mesic) Sigma	: -7 (S decay)	p2 : red
c -pI_mono	pion abs mono	: -8 (external)	p2 : blue
c




	subroutine K_reaction
	implicit none
c ... local
	real rand
c ... external
	real rn
c ... common primary reaction ratio
      real  r_knucl, r_two_nucl, r_quasi_free, r_Lambda_Hyper, r_Sigma_Hyper
      common /prim_ratio/ r_knucl, r_two_nucl, r_quasi_free, r_Lambda_Hyper, r_Sigma_Hyper
c common for debug
	logical debug_F
      integer ev_NUM, ev_error
      common /DeBugging/ debug_F, ev_NUM, ev_error
c>>c common for debug2
c>>	logical knucl_f
c>>	integer kdecay
c>>      common /DeBugging2/ knucl_f, kdecay
c begin
c>>			knucl_f = .false.
              rand = rn()
c ....              if(.true.) then
c ....			call KHe_Lt
c ....              else if(rand .lt. r_knucl) then
c ....              if(.true.) then
c ....                  call Lambda_Hyper_nuclei
c ....              else if(rand .lt. r_knucl) then
               if(rand .lt. r_knucl) then
c>>			if(debug_F .and. (ev_NUM .ge. ev_error))
c>>     &			 write(*,*) ' ev_Num = ', ev_NUM, '   reaction = knucl'
c>>				knucl_f = .true.
c>>				kdecay = 0
                  call K_3He_nuclei
               else if(rand .lt. r_Lambda_Hyper + r_knucl) then
c>>			if(debug_F .and. (ev_NUM .ge. ev_error))
c>>     &			 write(*,*) ' ev_Num = ', ev_NUM, '   reaction = Lambda_Hyper'
                  call Lambda_Hyper_nuclei
               else if(rand .lt. r_Sigma_Hyper + r_Lambda_Hyper + r_knucl) then
c>>			if(debug_F .and. (ev_NUM .ge. ev_error))
c>>     &			 write(*,*) ' ev_Num = ', ev_NUM, '   reaction = Sigma_Hyper'
                  call Sigmap_Hyper_nuclei
               else if(rand .lt. r_two_nucl + r_Sigma_Hyper 
     &               + r_Lambda_Hyper + r_knucl) then
c>>			if(debug_F .and. (ev_NUM .ge. ev_error))
c>>     &			 write(*,*) ' ev_Num = ', ev_NUM, '   reaction = two_body_abs'
                  call two_body_abs
               else
c>>			if(debug_F .and. (ev_NUM .ge. ev_error))
c>>     &			 write(*,*) ' ev_Num = ', ev_NUM, '   reaction = Quasi_Free'
                  call Quasi_Free_Process
               endif
		   call branch_check
		   call hyperon_travel
		   call pion_travel
		   call proton_travel 
		   call deuteron_travel 
	return 
	end






	subroutine pion_travel
	implicit none
c ... common /setup/ for simulation run-condition, counter resolution and its efficiency
	integer FF_knucl_decay, multi_set, k_decay_set
	logical Kstop_cor
      real  delta_x, delta_y, delta_T0, delta_NC, TC_eff, T0_eff
      common /setup/ delta_x, delta_y, delta_T0, delta_NC, TC_eff, T0_eff,
     &	FF_knucl_decay, multi_set, k_decay_set, Kstop_cor
c ... common /masses/
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
c ... common /masses2/
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common for branch 
      real p_quasi(8), p_SL_conv(8), p_Y_scat(8), p_pi_scat(8), p_pi_abs(8)
      common /branch/ p_quasi, p_SL_conv, p_Y_scat, p_pi_scat, p_pi_abs
c ... common /branch_1N_2N/ for single nucleon reaction ratio
	real  r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_1N_2N_K2NS, r_1N_2N_K2NL, r_2N_3N_piEx_abs
	common /branch_1N_2N/ r_1N_2N_S, r_1N_2N_L, r_1N_2N_SLC,
     &	r_1N_2N_SNS, r_1N_2N_LNS, r_1N_2N_piS,
     &	r_1N_2N_K2NS, r_1N_2N_K2NL, r_2N_3N_piEx_abs
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c ... common /kaon/ for kaon trajectory
      real  kaon_point(3) ! position of the K-reaction
      real  kt_vector(3) ! trajectory of the kaon injection
      real  kt_point(3) ! position of the K-reaction
      real  K_stop_time, K_flight_time, dL_T0
      common /kaon/ kaon_point, kt_point, kt_vector, K_stop_time, K_flight_time, dL_T0
c local 
	integer k, STP /-1/, PID, stack_size, reactionID
	integer box, status, init, react, decay, multi, fluct, N_nucl, N_pickup, iflag
	real p_helium4, v_helium4(3), p_triton, v_triton(3), p_p1, v_p1(3)
	real p_pi, v_pi(3), point_pi(3), time_pi
	real p_n1, v_n1(3), p_n2, v_n2(3), p_n3, v_n3(3)
	real p_deuteron, v_deuteron(3)
	real diff, dcross(3), diffv(3)
	real time_n1, pnt_n1(3) 
	integer j
c common /nucl_ract/ 
	integer nucl_prod
	real t_nuclr(20), p_nuclr(20), pnt_nuclr(3, 20), v_nuclr(3, 20)
	common /nucl_ract/ nucl_prod, t_nuclr, p_nuclr, pnt_nuclr, v_nuclr
c ... constant /NDPT/ for constant neutron background level
	real n_prod_dpit
	common /NDPT/ n_prod_dpit
c common for debug
	logical debug_F
      integer ev_NUM, ev_error
      common /DeBugging/ debug_F, ev_NUM, ev_error
c external 
	real rn, vertex_diff, gauss, p_tmp
c begin
      call get_stack_size( stack_size )
c>	if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'pion_travel', stack_size
c vertex calculation by pion
      do k = 1, stack_size
         call get_stack(k, PID, p_pi, v_pi, point_pi, time_pi, reactionID)
c	   if(time_pi.gt.100.) write(*,*) 'time_pi --', time_pi, reactionID
         if(abs(PID) .eq. PID_pion) then
	      diff = 10 * 
     &		vertex_diff(kt_point, kt_vector, point_pi, v_pi, dcross, diffv)
		if(diff .lt. 20.) then
		   p_tmp = p_pi + gauss( 0.,  0.764)
		   if (PID .eq. PID_pion) call td_hf1(1000, p_tmp, 1.)
		   if (PID .eq. -PID_pion) call td_hf1(1001, p_tmp, 1.)
		endif
	      init  = 0
		if(PID .eq. -PID_pion) then
c 	...      allow reaction & keep on traveling & stop when inelactic   
	         react = 4
		else
c 	...      allow reaction & keep on traveling
	         react = 2
		endif
	      decay = 0
	      multi = multi_set
	      fluct = 1
	      call Travel(p_pi,point_pi,v_pi,PID,Box,time_pi,status,
     &               init, react, decay, multi, fluct)
c?????
c	write(*,*) 'nucl_prod, n_prod_dpit', nucl_prod, n_prod_dpit
		if(nucl_prod .ne. 0) then
		   Do j = 1, nucl_prod
      	      if( rn() .lt. n_prod_dpit ) then
			   time_n1 = t_nuclr(j)
			   p_n1 = p_nuclr(j)
	    		   pnt_n1(1) = pnt_nuclr(1, j)
	    		   pnt_n1(2) = pnt_nuclr(2, j)
	    		   pnt_n1(3) = pnt_nuclr(3, j)
	    		   v_n1(1) = v_nuclr(1, j)
	    		   v_n1(2) = v_nuclr(2, j)
	    		   v_n1(3) = v_nuclr(3, j)
			   call put_stack(PID_neutron, p_n1, v_n1, pnt_n1, time_n1, pi_abs)
			endif
		   enddo
		endif
c>		if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'pion_travel -Travel', k
	      if( (status .eq. 2 .and. (Box.ge. 3 .and. Box.le.16 
     &		.or.   Box.ge.38 .and. Box.le.43
     &		.or.   Box.ge.50 .and. Box.le.51) ) .OR. 
     &          (status .eq. -1 .and. (Box.ge. 3 .and. Box.le.16 
     &		.or.   Box.ge.38 .and. Box.le.43
     &		.or.   Box.ge.50 .and. Box.le.51) ) ) then
		   if( status .eq. -1 ) then
		      p_helium4 = 0.
		      call sphrrn(v_helium4)
		   endif
		   if(Box .eq. 3 .and. rn() .lt. 0.194) then
c>			if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'pion_abs mono-energetic'
                  iflag = 0
                  call reaction_in_flight_2( 
     &		      M_helium4, p_helium4, v_helium4, M_pi, p_pi, v_pi,
     &			M_n, M_triton, p_n1, p_triton, v_n1, v_triton, iflag )
      	      call put_stack(PID_neutron, p_n1, v_n1, point_pi, time_pi, -pi_mono)
		   else 
                  N_nucl = 4
                  N_pickup = 2
                  iflag = 0
		      if(rn() .lt. r_2N_3N_piEx_abs) then
c>		   	   if(debug_F .and. (ev_NUM .ge. ev_error)) then
c>		   		write(*,*) 'pion_abs n n d'
c>		   		write(*,*) M_helium4, p_helium4, v_helium4
c>		   		write(*,*) M_pi, p_pi, v_pi
c>		         endif
		         if(rn() .lt. 0.9) then
      	            call reaction_in_flight_3(
     &		         M_helium4, p_helium4, v_helium4, M_pi, p_pi, v_pi,
     &                     M_n,  M_n,  M_deuteron,
     &                     p_n1, p_n2, p_deuteron, 
     &                     v_n1, v_n2, v_deuteron, N_nucl, N_pickup, iflag )
      	            call put_stack(PID_neutron, p_n1, v_n1, point_pi, time_pi, -pi_abs)
      	            call put_stack(PID_neutron, p_n2, v_n2, point_pi, time_pi, -pi_abs)
		         else 
      	            call breakup_in_flight_4(
     &		         M_helium4, p_helium4, v_helium4, M_pi, p_pi, v_pi,
     &                     M_n,  M_p,  M_n,  M_n,  
     &                     p_n1, p_p1, p_n2, p_n3, 
     &                     v_n1, v_p1, v_n2, v_n3, N_nucl, N_pickup, iflag )
      	            call put_stack(PID_proton, p_p1, v_p1, point_pi, time_pi, -pi_abs)
      	            call put_stack(PID_neutron, p_n1, v_n1, point_pi, time_pi, -pi_abs)
      	            call put_stack(PID_neutron, p_n2, v_n2, point_pi, time_pi, -pi_abs)
      	            call put_stack(PID_neutron, p_n3, v_n3, point_pi, time_pi, -pi_abs)
		         endif
		      else 
c>			   if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) 'pion_abs n n n p'
         	         call breakup_in_flight_4(
     &		      M_helium4, p_helium4, v_helium4, M_pi, p_pi, v_pi,
     &                  M_n,  M_n,  M_p,  M_n,   
     &                  p_n1, p_n2, p_p1, p_n3, 
     &                  v_n1, v_n2, v_p1, v_n3, N_nucl, N_pickup, iflag )
      	         call put_stack(PID_neutron, p_n1, v_n1, point_pi, time_pi, -pi_abs)
      	         call put_stack(PID_neutron, p_n2, v_n2, point_pi, time_pi, -pi_abs)
      	         call put_stack(PID_neutron, p_n3, v_n3, point_pi, time_pi, -pi_abs)
      	         call put_stack(PID_proton, p_p1, v_p1, point_pi, time_pi, -pi_abs)
		      endif
		   endif
		endif
	   endif
	enddo
	return
	end





	subroutine proton_travel
	implicit none
c ... common /setup/ for simulation run-condition, counter resolution and its efficiency
	integer FF_knucl_decay, multi_set, k_decay_set
	logical Kstop_cor
      real  delta_x, delta_y, delta_T0, delta_NC, TC_eff, T0_eff
      common /setup/ delta_x, delta_y, delta_T0, delta_NC, TC_eff, T0_eff,
     &	FF_knucl_decay, multi_set, k_decay_set, Kstop_cor
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c local 
	integer k, PID, stack_size, reactionID
	integer box, status, init, react, decay, multi, fluct
	real p_p, v_p(3), point_p(3), time_p
c begin
      call  get_stack_size( stack_size )
      do k = 1, stack_size
         call get_stack(k, PID, p_p, v_p, point_p, time_p, reactionID)
         if(PID .eq. PID_proton) then
	      init  = 0
	      react = 2
	      decay = 0
	      multi = multi_set
	      fluct = 1
	      call Travel(p_p,point_p,v_p,PID_proton,Box,time_p,status,
     &               init, react, decay, multi, fluct)
	   endif
	enddo
	return
	end





	subroutine deuteron_travel
	implicit none
c ... common /setup/ for simulation run-condition, counter resolution and its efficiency
	integer FF_knucl_decay, multi_set, k_decay_set
	logical Kstop_cor
      real  delta_x, delta_y, delta_T0, delta_NC, TC_eff, T0_eff
      common /setup/ delta_x, delta_y, delta_T0, delta_NC, TC_eff, T0_eff,
     &	FF_knucl_decay, multi_set, k_decay_set, Kstop_cor
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c local 
	integer k, PID, stack_size, reactionID
	integer box, status, init, react, decay, multi, fluct
	real p_p, v_p(3), point_p(3), time_p
c begin
      call  get_stack_size( stack_size )
      do k = 1, stack_size
         call get_stack(k, PID, p_p, v_p, point_p, time_p, reactionID)
         if(PID .eq. PID_deuteron) then
	      init  = 0
	      react = 0
	      decay = 0
	      multi = multi_set
	      fluct = 1
c	write(*,*) 'bef', p_p, v_p, point_p
	      call Travel(p_p,point_p,v_p,PID_deuteron,Box,time_p,status,
     &               init, react, decay, multi, fluct)
c	write(*,*) 'aft', p_p, v_p, point_p
c	write(*,*) Box, Status
	   endif
	enddo
	return
	end





	subroutine hyperon_travel
	implicit none
c output
c local 
	integer k, PID, stack_size, reactionID
	real p_p, v_p(3), point_p(3), time_p
c common 
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c begin
      call  get_stack_size( stack_size )
      do k = 1, stack_size
         call get_stack(k, PID, p_p, v_p, point_p, time_p, reactionID)
         if(PID .eq. PID_Lambda) then
	      call Lambda_decay(p_p, v_p, point_p, time_p, reactionID)
         else if(PID .eq. PID_SigmaP) then
	      call SigmaP_decay(p_p, v_p, point_p, time_p, reactionID)
         else if(PID .eq. PID_Sigma0) then
	      call Sigma0_decay(p_p, v_p, point_p, time_p, reactionID)
         else if(PID .eq. PID_SigmaM) then
	      call SigmaM_decay(p_p, v_p, point_p, time_p, reactionID)
	   endif
	enddo
	return
	end



	subroutine branch_check
	implicit none
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c common for branch check
      real H3_pim_Sp, dn_pim_Sp, pnn_pim_Sp, nnn_pi0_Sp, nnn_Sp, tot_Sp
      real H3_pip_Sm, dn_pip_Sm, pnn_pip_Sm, He3_pi0_Sm, dp_pi0_Sm
      real ppn_pi0_Sm, dp_Sm, ppn_Sm, tot_Sm
      real He3_pim_L, dp_pim_L, ppn_pim_L, He3_pim_S0, dp_ppn_pim_S0
      real dn_pnn_pi0_L_S0, dn_pnn_L_S0, nnn_pip_L_S0, tot_L_S0   
      real ext_Sm_conv
      common /branch_check/  H3_pim_Sp, dn_pim_Sp, pnn_pim_Sp
     &      , nnn_pi0_Sp, nnn_Sp, tot_Sp
     &      , H3_pip_Sm, dn_pip_Sm, pnn_pip_Sm, He3_pi0_Sm, dp_pi0_Sm
     &      , ppn_pi0_Sm, dp_Sm, ppn_Sm, tot_Sm
     &      , He3_pim_L, dp_pim_L, ppn_pim_L, He3_pim_S0, dp_ppn_pim_S0
     &      , dn_pnn_pi0_L_S0, dn_pnn_L_S0, nnn_pip_L_S0, tot_L_S0
     &      , ext_Sm_conv
      real L_hyp_mesic, L_pi0_t, S0_pi0_t, L_hyp_nmesic
      common /branch_misc/  L_hyp_mesic, L_pi0_t, S0_pi0_t, L_hyp_nmesic
c common for debug
	logical debug_F
      integer ev_NUM, ev_error
      common /DeBugging/ debug_F, ev_NUM, ev_error
c local
	integer check, stack_size, k, PID, reactionID
	real p_p, v_p(3), point_p, time_p
	integer PID_helium4 /17/
c begin
	check = 0
      call  get_stack_size( stack_size )
      do k = 1, stack_size
         call get_stack(k, PID, p_p, v_p, point_p, time_p, reactionID)
         if(PID .eq. PID_Lambda) then
		check = check + 10000
         else if(PID .eq. PID_SigmaP) then
		check = check + 20000
         else if(PID .eq. PID_Sigma0) then
		check = check + 30000
         else if(PID .eq. PID_SigmaM) then
		check = check + 40000
         else if(PID .eq. PID_pion) then
		check = check + 1000
         else if(PID .eq. PID_pi0) then
		check = check + 2000
         else if(PID .eq. -PID_pion) then
		check = check + 3000
         else if(PID .eq. PID_deuteron) then
		check = check + 100
         else if(PID .eq. PID_triton) then
		check = check + 200
         else if(PID .eq. PID_helium3) then
		check = check + 300
         else if(PID .eq. PID_helium4) then
		check = check + 400
         else if(PID .eq. PID_proton) then
		check = check + 10
         else if(PID .eq. PID_neutron) then
		check = check + 1
	   endif
	enddo

c>	if(debug_F .and. (ev_NUM .ge. ev_error)) write(*,*) '$$$$$ reaction = ', check

c ... SigmaP
      if (check .eq. 23200) then
	   H3_pim_Sp = H3_pim_Sp + 1
      else if (check .eq. 23101) then
	   dn_pim_Sp = dn_pim_Sp + 1
      else if (check .eq. 23012) then
	   pnn_pim_Sp = pnn_pim_Sp + 1
      else if (check .eq. 22003) then
	   nnn_pi0_Sp = nnn_pi0_Sp + 1
      else if (check .eq. 20003) then
	   nnn_Sp = nnn_Sp + 1
c ... SigmaM
      else if (check .eq. 41200) then
	   H3_pip_Sm = H3_pip_Sm + 1
      else if (check .eq. 41101) then
	   dn_pip_Sm = dn_pip_Sm + 1
      else if (check .eq. 41012) then
	   pnn_pip_Sm = pnn_pip_Sm + 1
      else if (check .eq. 42300) then
	   He3_pi0_Sm = He3_pi0_Sm + 1
      else if (check .eq. 42110) then
	   dp_pi0_Sm = dp_pi0_Sm + 1
      else if (check .eq. 42021) then
	   ppn_pi0_Sm = ppn_pi0_Sm + 1
      else if (check .eq. 40110) then
	   dp_Sm = dp_Sm + 1
      else if (check .eq. 40021) then
	   ppn_Sm = ppn_Sm + 1
c ... Lambda
      else if (check .eq. 13300) then
	   He3_pim_L = He3_pim_L + 1
      else if (check .eq. 13110) then
	   dp_pim_L = dp_pim_L + 1
      else if (check .eq. 13021) then
	   ppn_pim_L = ppn_pim_L + 1
      else if (check .eq. 12012) then
	   dn_pnn_pi0_L_S0 = dn_pnn_pi0_L_S0 + 1
      else if (check .eq. 12101) then 
	   dn_pnn_pi0_L_S0 = dn_pnn_pi0_L_S0 + 1
      else if (check .eq. 12200) then 
	   L_pi0_t = L_pi0_t + 1
      else if (check .eq. 10101) then
	   dn_pnn_L_S0 = dn_pnn_L_S0 + 1
      else if (check .eq. 10012) then
	   dn_pnn_L_S0 = dn_pnn_L_S0 + 1
      else if (check .eq. 11003) then
	   nnn_pip_L_S0 = nnn_pip_L_S0 + 1
c ... Sigma0
      else if (check .eq. 33300) then
	   He3_pim_S0 = He3_pim_S0 + 1
      else if (check .eq. 33110) then
	   dp_ppn_pim_S0 = dp_ppn_pim_S0 + 1
      else if (check .eq. 33021) then
	   dp_ppn_pim_S0 = dp_ppn_pim_S0 + 1
      else if (check .eq. 32200) then  
	   S0_pi0_t = S0_pi0_t + 1
      else if (check .eq. 32101) then
	   dn_pnn_pi0_L_S0 = dn_pnn_pi0_L_S0 + 1
      else if (check .eq. 32012) then
	   dn_pnn_pi0_L_S0 = dn_pnn_pi0_L_S0 + 1
      else if (check .eq. 30101) then
	   dn_pnn_L_S0 = dn_pnn_L_S0 + 1
      else if (check .eq. 30012) then
	   dn_pnn_L_S0 = dn_pnn_L_S0 + 1
      else if (check .eq. 30003) then
	   nnn_pip_L_S0 = nnn_pip_L_S0 + 1
      else if (check .eq. 6400) then
	   L_hyp_mesic =  L_hyp_mesic + 1
      else if (check .eq. 5400) then
	   L_hyp_mesic =  L_hyp_mesic + 1
      else if (check .eq. 3013) then
	   L_hyp_nmesic =  L_hyp_nmesic + 1
      else if (check .eq. 3102) then
	   L_hyp_nmesic =  L_hyp_nmesic + 1
      else 
	   write(*,*) 'ev_NUM = ', ev_NUM
	   write(*,*) '??? check faild reaction = ', check, 
     &		'   stack_size = ',stack_size 
         do k = 1, stack_size
            call get_stack(k, PID, p_p, v_p, point_p, time_p, reactionID)
	      write(*,*) '      k :',k,'   PID = ', PID, p_p, ' (MeV/c)'
	   enddo
c>	if(debug_F) stop
      endif
	return
	end


 


      subroutine  define_masses
      implicit NONE
c common block
c mass and particle ID in this routine
      real  M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      common /masses/ M_k, M_p, M_n, M_L, M_pi, M_pi0, M_Sp, M_S0, M_Sm
      real  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
      common /masses2/  M_helium4, M_helium3, M_triton, M_deuteron, M_nn
c ... common /PIDs/
      integer PID_pion, PID_pi0, PID_proton, PID_neutron,
     &	PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
      common /PIDs/ PID_pion, PID_pi0, PID_proton, PID_neutron, 
     &      PID_Lambda, PID_SigmaP, PID_SigmaM, PID_Sigma0,
     &	PID_deuteron, PID_triton, PID_helium3
c produced particle stack
      real p_stack(8,100)
      integer pid_stack(100), rid_stack(100), stack
      common /STK/ p_stack, pid_stack, rid_stack, stack
c ... common /RIDS/ reaction ID
	integer KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
	common /RIDS/ KN, tnL, tnS, pi_abs, SLC, QFL, QFS, pi_mono, CBG
c data for mass
      real Atomic_Mass / 931.494013 /
      data M_k / 493.677/, M_p / 938.27231/, M_n / 939.56563/ 
      data M_L / 1115.683/, M_pi / 139.56995/, M_pi0 /134.9764/
      data M_Sp / 1189.34/, M_S0 / 1192.642/, M_Sm / 1197.449/ 
      data  M_nn       / 1879.13126 / ! 2 neutron
      data  PID_pion /2/, PID_pi0 /3/, PID_proton /7/, PID_neutron /8/, 
     &            PID_Lambda /9/,   PID_SigmaP /10/, PID_SigmaM /-11/,
     &            PID_Sigma0 /12/,  PID_deuteron /14/, PID_triton /15/, 
     &		PID_helium3 /16/
c data for PIDS
	data KN /1/, tnL /2/, tnS /3/, pi_abs /4/, SLc /5/, QFL /6/, QFS /7/, pi_mono /8/
	data CBG /8/
c
	M_helium4 = 4 * Atomic_Mass + 2.424911  - 2 * 0.510998902
	M_helium3 = 3 * Atomic_Mass + 14.931204 - 2 * 0.510998902
	M_triton    = 3 * Atomic_Mass + 14.949794- 1 *  0.510998902
	M_deuteron = 2 * Atomic_Mass + 13.135720 - 1 *  0.510998902
      return
      end
