ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                           c
c     subroutine package for topdrawer histograms                           c
c                                                                           c
c                                                                           c
c     the followings are list of subroutines included and how-to-use        c
c histogram                                                                 c
c       td_Hdef1(N, title_top, title_bottom, title_left,                    c
c    &      Nbin, lo_lim, up_lim )                                          c
c         N : histogram id. no.                                             c
c         title_name : histogram title                                      c
c         Nbin : no. of bin                                                 c
c         lo_lim : lower limit                                              c
c         up_lim : upper limit                                              c
c 2-dim histogram                                                           c
c       td_Hdef2(N, title_top, title_bottom, title_left,                    c
c     &             Nbin_x, lo_lim_x, up_lim_x,                             c
c     &             Nbin_y, lo_lim_y, up_lim_y )                            c
c fill histogram                                                            c
c       td_Hf1(N, data, weight)                                             c
c fill 2-dim histogram                                                      c
c       td_Hf2(N, data_x, data_y, weight)                                   c
c output one histogram to a td-format                                       c
c       td_Houtput(unit, N, cf, (peak_limit, cont_n))                       c
c          unit : logical unit number                                       c
c          cf: 'new'      for new plot                                      c
c            : 'overlay' for overlay histograms                             c
c         (optional, only for 2-dim plot)                                   c
c          peak_limit : 0-1 maximum contour height relative to maximum bin  c
c          cont_n : contour number                                          c
c type histogram buffer status                                              c
c      td_buffer_check                                                      c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine td_init
      Implicit NONE
c common
	integer space_max, h_max, hn_max, c_max
      parameter ( space_max = 400000, h_max = 2000,
     & hn_max=10000, c_max = 140000 )
      real h_buffer( space_max )
      integer pointer(h_max), c_pointer(3,h_max),
     &      hid(hn_max), kind(h_max), n_call(h_max)
      real l_limit(2,h_max), step(2,h_max), h_bin(2,h_max)
      integer n_hist, h_buffer_p, c_buffer_p
      character*(c_max) c_buffer
      common / td_book / h_buffer, c_pointer, pointer, hid, kind, n_call,
     &      l_limit, step, h_bin, n_hist, h_buffer_p, c_buffer_p, c_buffer
	common /openf/ open, new_open
	logical open, new_open
c local
      integer j
c begin
      n_hist = 0
      h_buffer_p = 0
      c_buffer_p = 0
      do j = 1, space_max
         h_buffer(j) = 0.
      enddo
      do j = 1, hn_max
         hid(j) = -1
      enddo
	open = .false.
      return
      end



	subroutine td_buffer_check
c common
	integer space_max, h_max, hn_max, c_max
      parameter ( space_max = 400000, h_max = 2000,
     & hn_max=10000, c_max = 140000 )
      real h_buffer( space_max )
      integer pointer(h_max), c_pointer(3,h_max),
     &      hid(hn_max), kind(h_max), n_call(h_max)
      real l_limit(2,h_max), step(2,h_max), h_bin(2,h_max)
      integer n_hist, h_buffer_p, c_buffer_p
      character*(c_max) c_buffer
      common / td_book / h_buffer, c_pointer, pointer, hid, kind, n_call,
     &      l_limit, step, h_bin, n_hist, h_buffer_p, c_buffer_p, c_buffer
c begin
	write(*,*) 'TD_HIST_buffer status'
	write(*,100) h_buffer_p, space_max, 100 * h_buffer_p / space_max
	write(*,110) n_hist, h_max, 100 * n_hist / h_max
	write(*,120) c_buffer_p, c_max, 100 * c_buffer_p /  c_max
100	format('space_max : ', i8, ' / ', i8, i12, ' %')
110	format('h_max     : ', i8, ' / ', i8, i12, ' %')
120	format('c_max     : ', i8, ' / ', i8, i12, ' %')
	return
	end



      subroutine td_Hdef1(HID_N, title_top, title_bottom, title_left,
     &		Nbin, lo_lim, up_lim )
      Implicit NONE
c input
      real lo_lim, up_lim
      integer HID_N, Nbin
      character*(*) title_top, title_bottom, title_left
c common
	integer space_max, h_max, hn_max, c_max
      parameter ( space_max = 400000, h_max = 2000,
     & hn_max=10000, c_max = 140000 )
      real h_buffer( space_max )
      integer pointer(h_max), c_pointer(3,h_max),
     &      hid(hn_max), kind(h_max), n_call(h_max)
      real l_limit(2,h_max), step(2,h_max), h_bin(2,h_max)
      integer n_hist, h_buffer_p, c_buffer_p
      character*(c_max) c_buffer
      common / td_book / h_buffer, c_pointer, pointer, hid, kind, n_call,
     &      l_limit, step, h_bin, n_hist, h_buffer_p, c_buffer_p, c_buffer
c local
      character*80 text
      integer c_lng, c_buffer_p_end
c	integer j
c format
100   format(Q,A)
c begin
      n_hist = n_hist + 1
c	write(*,*) 'hdef1', n_hist, HID_N
      if(HID_N.gt.hn_max) then
        write (*,*) 'Error: Histogram-ID number buffer overflow hn_max = ', hn_max
	  write (*,*) 'requesed at HIstogram_ID_Number (HID) = ', HID_N
        write (*,*) ' ... You need to expand "nh_max" in td_hist.f!'
        stop
      Endif
      if(n_hist.gt.h_max) then
        write (*,*) 'Error: Histogram number buffer overflow h_max = ', h_max
	  write (*,*) 'requesed at HIstogram_ID_Number (HID) = ', HID_N
        write (*,*) ' ... You need to expand "h_max" in td_hist.f!'
        stop
      Endif
      if( n_hist .ge. 2) then
          if(hid(HID_N) .ne. -1) then
            write (*,*) 'Error: Histogram number duplicated at HID_N = ', HID_N
c        do j = 1, n_hist-1
c            write (*,*) j, hid(j)
c	enddo
            stop
          endif
      endif
      hid( HID_N ) = n_hist
      kind( n_hist ) = 1
      l_limit(1,n_hist) = lo_lim
      h_bin(1,n_hist) = Nbin
      if(Nbin.le.0) then
        write (*,*) 'Error: irregal number of bin at HID number = ', HID_N
        stop
      Endif
      step(1,n_hist) = ( up_lim - lo_lim ) / Nbin
      pointer( N_hist ) = h_buffer_p + 1
      h_buffer_p = h_buffer_p + Nbin
      if(h_buffer_p.gt.space_max) then
        write (*,*) 'Error: Histogram buffer overflow space_max = ', space_max
	  write (*,*) 'requesed at HIstogram_ID_Number (HID) = ', HID_N
        write (*,*) ' ... You need to expand "space_max" in td_hist.f!'
        stop
      Endif
c
      read(title_top, 100) c_lng, text
      if(c_lng.ne.0) then
         c_buffer_p_end = c_buffer_p + c_lng
         c_buffer_p = c_buffer_p + 1
         if(c_buffer_p_end.gt.c_max) then
            write (*,*) 'Error: Histogram character buffer overflow c_max = ', c_max
		write (*,*) 'requesed at HIstogram_ID_Number (HID) = ', HID_N
            write (*,*) ' ... You need to expand "c_max" in td_hist.f!'
            stop
         endif
         c_pointer(1,n_hist) = c_buffer_p
         c_buffer(c_buffer_p:c_buffer_p_end) = text(1:c_lng)
         c_buffer_p = c_buffer_p_end
      else
         c_pointer(1,n_hist) = c_buffer_p
      endif
      read(title_bottom, 100) c_lng, text
      if(c_lng.ne.0) then
         c_buffer_p_end = c_buffer_p + c_lng
         c_buffer_p = c_buffer_p + 1
         if(c_buffer_p_end.gt.c_max) then
            write (*,*) 'Error: Histogram character buffer overflow c_max = ', c_max
		write (*,*) 'requesed at HIstogram_ID_Number (HID) = ', HID_N
            write (*,*) ' ... You need to expand "c_max" in td_hist.f!'
            stop
         endif
         c_pointer(2,n_hist) = c_buffer_p
         c_buffer(c_buffer_p:c_buffer_p_end) = text(1:c_lng)
         c_buffer_p = c_buffer_p_end
      else
         c_pointer(2,n_hist) = c_buffer_p
      endif
      read(title_left, 100) c_lng, text
      if(c_lng.ne.0) then
         c_buffer_p_end = c_buffer_p + c_lng
         c_buffer_p = c_buffer_p + 1
         if(c_buffer_p_end.gt.c_max) then
            write (*,*) 'Error: Histogram character buffer overflow c_max = ', c_max
		write (*,*) 'requesed at HIstogram_ID_Number (HID) = ', HID_N
            write (*,*) ' ... You need to expand "c_max" in td_hist.f!'
            stop
         endif
         c_pointer(3,n_hist) = c_buffer_p
         c_buffer(c_buffer_p:c_buffer_p_end) = text(1:c_lng)
         c_buffer_p = c_buffer_p_end
      else
         c_pointer(3,n_hist) = c_buffer_p
      endif
      Return
      End



      subroutine td_Hf1(HID_N, data, weight)
      Implicit NONE
c input
      integer HID_N
      real data, weight
c common
	integer space_max, h_max, hn_max, c_max
      parameter ( space_max = 400000, h_max = 2000,
     & hn_max=10000, c_max = 140000 )
      real h_buffer( space_max )
      integer pointer(h_max), c_pointer(3,h_max),
     &      hid(hn_max), kind(h_max), n_call(h_max)
      real l_limit(2,h_max), step(2,h_max), h_bin(2,h_max)
      integer n_hist, h_buffer_p, c_buffer_p
      character*(c_max) c_buffer
      common / td_book / h_buffer, c_pointer, pointer, hid, kind, n_call,
     &      l_limit, step, h_bin, n_hist, h_buffer_p, c_buffer_p, c_buffer
c local
      integer j, hist_id
	real x
c begin
      hist_id = hid( HID_N )
      if(hist_id .eq. -1) then
         write(*,*) 'warning: undefined histogram ID', HID_N
         return
      endif
      x = (data - l_limit(1,hist_id)) / step(1,hist_id)
      j = int(x - 1.e-4)
      if(x .ge. - 1.e-4 .and. j .lt. h_bin(1,hist_id)) then
        j = j + pointer(hist_id)
        h_buffer(j) = h_buffer(j) + weight
      Endif
      n_call(hist_id) = n_call(hist_id) + 1
      Return
      End



      subroutine td_Hs1(HID_N, x_low, x_high, sum)
      Implicit NONE
c input
      integer HID_N
      real x_low, x_high
c common
	integer space_max, h_max, hn_max, c_max
      parameter ( space_max = 400000, h_max = 2000,
     & hn_max=10000, c_max = 140000 )
      real h_buffer( space_max )
      integer pointer(h_max), c_pointer(3,h_max),
     &      hid(hn_max), kind(h_max), n_call(h_max)
      real l_limit(2,h_max), step(2,h_max), h_bin(2,h_max)
      integer n_hist, h_buffer_p, c_buffer_p
      character*(c_max) c_buffer
      common / td_book / h_buffer, c_pointer, pointer, hid, kind, n_call,
     &      l_limit, step, h_bin, n_hist, h_buffer_p, c_buffer_p, c_buffer
c local
      integer j, hist_id
      integer j_low, j_high
	real x, sum
c begin
	sum = 0.
      hist_id = hid( HID_N )
      if(hist_id .eq. -1) then
         write(*,*) 'warning: undefined histogram ID', HID_N
         return
      endif
      x = (x_low - l_limit(1,hist_id)) / step(1,hist_id)
      j = int(x - 1.e-4)
      if(x .ge. - 1.e-4 .and. j .lt. h_bin(1,hist_id)) then
	   j_low = j
	else
	   write(*,*) 'error in sum HID=', HID_N
	   return
	endif
      x = (x_high - l_limit(1,hist_id)) / step(1,hist_id)
      j = int(x - 1.e-4)
      if(x .ge. - 1.e-4 .and. j .lt. h_bin(1,hist_id)) then
	   j_high = j
	else
	   write(*,*) 'error in sum HID=', HID_N
	   return
	endif
      j_low = j_low + pointer(hist_id)
      j_high = j_high + pointer(hist_id)
c	write(*,*) 'j_low, j_high', j_low, j_high
	Do j = j_low, j_high
        sum = h_buffer(j) + sum
c	  write(*,*) 'j, buffer', j, h_buffer(j)
      EndDo
      Return
      End



      subroutine td_Hc1(HID_N, scale, data, error, chi)
      Implicit NONE
c input
      integer HID_N
c common
	integer space_max, h_max, hn_max, c_max
      parameter ( space_max = 400000, h_max = 2000,
     & hn_max=10000, c_max = 140000 )
      real h_buffer( space_max )
      integer pointer(h_max), c_pointer(3,h_max),
     &      hid(hn_max), kind(h_max), n_call(h_max)
      real l_limit(2,h_max), step(2,h_max), h_bin(2,h_max)
      integer n_hist, h_buffer_p, c_buffer_p
      character*(c_max) c_buffer
      common / td_book / h_buffer, c_pointer, pointer, hid, kind, n_call,
     &      l_limit, step, h_bin, n_hist, h_buffer_p, c_buffer_p, c_buffer
c local
      integer j, hist_id
      integer k
	real sum, data(0:200), error(0:200), scale, chi
c begin
	sum = 0.
	k = 0
      hist_id = hid( HID_N )
c	write(*,*) pointer(hist_id+1) - pointer(hist_id)
	Do j = pointer(hist_id)+10, pointer(hist_id) + 180
c	   write(*,*) j - pointer(hist_id), k, error(j - pointer(hist_id))
        sum = sum + ( ( h_buffer(j)*scale -  data(j - pointer(hist_id)) )
     &                / error(j - pointer(hist_id)) ) **2
         K = k + 1
      EndDo
c      write(*,*) 'chi.sq.=', sum/k, k
	chi = sum/k
      Return
      End



      subroutine td_Hdef2(HID_N, title_top, title_bottom, title_left,
     &       Nbin_x, lo_lim_x, up_lim_x, Nbin_y, lo_lim_y, up_lim_y )
      Implicit NONE
c input
      integer HID_N
      real lo_lim_x, up_lim_x, lo_lim_y, up_lim_y
      integer Nbin_x, Nbin_y
      character*(*) title_top, title_bottom, title_left
c common
	integer space_max, h_max, hn_max, c_max
      parameter ( space_max = 400000, h_max = 2000,
     & hn_max=10000, c_max = 140000 )
      real h_buffer( space_max )
      integer pointer(h_max), c_pointer(3,h_max),
     &      hid(hn_max), kind(h_max), n_call(h_max)
      real l_limit(2,h_max), step(2,h_max), h_bin(2,h_max)
      integer n_hist, h_buffer_p, c_buffer_p
      character*(c_max) c_buffer
      common / td_book / h_buffer, c_pointer, pointer, hid, kind, n_call,
     &      l_limit, step, h_bin, n_hist, h_buffer_p, c_buffer_p, c_buffer
c local
      character*80 text
      integer c_lng, c_buffer_p_end
c format
100   format(Q,A)
c begin
      n_hist = n_hist + 1
      if(HID_N.gt.hn_max) then
        write (*,*) 'Error: Histogram-ID number buffer overflow hn_max = ', hn_max
	  write (*,*) 'requesed at HIstogram_ID_Number (HID) = ', HID_N
        write (*,*) ' ... You need to expand "hn_max" in td_hist.f!'
        stop
      Endif
      if(n_hist.gt.h_max) then
        write (*,*) 'Error: Histogram number buffer overflow h_max = ', h_max
	  write (*,*) 'requesed at HIstogram_ID_Number (HID) = ', HID_N
        write (*,*) ' ... You need to expand "h_max" in td_hist.f!'
        stop
      Endif
      if( n_hist .ge. 2) then
          if(hid(HID_N) .ne. -1) then
            write (*,*) 'Error: Histogram number duplicated at HID_N = ', HID_N
            stop
          endif
      endif
      hid( HID_N ) = n_hist
      kind( n_hist ) = 2
      l_limit(1,n_hist) = lo_lim_x
      l_limit(2,n_hist) = lo_lim_y
      h_bin(1,n_hist) = Nbin_x
      h_bin(2,n_hist) = Nbin_y
      if(Nbin_x.le.0 .or. Nbin_y.le.0) then
        write (*,*) 'Error: irregal number of bins at HID number = ', HID_N
        stop
      Endif
c      if(Nbin_x*Nbin_y.gt.7000) then
c        write (*,*) 'Warning: matrix might be too large for TD ', HID_N, '  N_x*N_y = ', Nbin_x*Nbin_y
c      Endif
      step(1,n_hist) = ( up_lim_x - lo_lim_x ) / Nbin_x
      step(2,n_hist) = ( up_lim_y - lo_lim_y ) / Nbin_y
      pointer( n_hist ) = h_buffer_p + 1
      h_buffer_p = h_buffer_p + Nbin_x * Nbin_y
      if(h_buffer_p.gt.space_max) then
        write (*,*) 'Error: Histogram buffer overflow space_max = ', space_max
	  write (*,*) 'requesed at HIstogram_ID_Number (HID) = ', HID_N
        write (*,*) ' ... You need to expand "space_max" in td_hist.f!'
        stop
      Endif
c
      read(title_top, 100) c_lng, text
      if(c_lng.ne.0) then
         c_buffer_p_end = c_buffer_p + c_lng
         c_buffer_p = c_buffer_p + 1
         if(c_buffer_p_end.gt.c_max) then
            write (*,*) 'Error: Histogram character buffer overflow c_max = ', c_max
		write (*,*) 'requesed at HIstogram_ID_Number (HID) = ', HID_N
            write (*,*) ' ... You need to expand "c_max" in td_hist.f!'
            stop
         endif
         c_pointer(1,n_hist) = c_buffer_p
         c_buffer(c_buffer_p:c_buffer_p_end) = text(1:c_lng)
         c_buffer_p = c_buffer_p_end
      else
         c_pointer(1,n_hist) = c_buffer_p
      endif
      read(title_bottom, 100) c_lng, text
      if(c_lng.ne.0) then
         c_buffer_p_end = c_buffer_p + c_lng
         c_buffer_p = c_buffer_p + 1
         if(c_buffer_p_end.gt.c_max) then
            write (*,*) 'Error: Histogram character buffer overflow c_max = ', c_max
		write (*,*) 'requesed at HIstogram_ID_Number (HID) = ', HID_N
            write (*,*) ' ... You need to expand "c_max" in td_hist.f!'
            stop
         endif
         c_pointer(2,n_hist) = c_buffer_p
         c_buffer(c_buffer_p:c_buffer_p_end) = text(1:c_lng)
         c_buffer_p = c_buffer_p_end
      else
         c_pointer(2,n_hist) = c_buffer_p
      endif
      read(title_left, 100) c_lng, text
      if(c_lng.ne.0) then
         c_buffer_p_end = c_buffer_p + c_lng
         c_buffer_p = c_buffer_p + 1
         if(c_buffer_p_end.gt.c_max) then
            write (*,*) 'Error: Histogram character buffer overflow c_max = ', c_max
		write (*,*) 'requesed at HIstogram_ID_Number (HID) = ', HID_N
           write (*,*) ' ... You need to expand "c_max" in td_hist.f!'
            stop
         endif
         c_pointer(3,n_hist) = c_buffer_p
         c_buffer(c_buffer_p:c_buffer_p_end) = text(1:c_lng)
         c_buffer_p = c_buffer_p_end
      else
         c_pointer(3,n_hist) = c_buffer_p
      endif
      Return
      End



      subroutine td_Hf2(HID_N, data_x, data_y, weight)
      Implicit NONE
c input
      integer HID_N
      real data_x, data_y, weight
c common
	integer space_max, h_max, hn_max, c_max
      parameter ( space_max = 400000, h_max = 2000,
     & hn_max=10000, c_max = 140000 )
      real h_buffer( space_max )
      integer pointer(h_max), c_pointer(3,h_max),
     &      hid(hn_max), kind(h_max), n_call(h_max)
      real l_limit(2,h_max), step(2,h_max), h_bin(2,h_max)
      integer n_hist, h_buffer_p, c_buffer_p
      character*(c_max) c_buffer
      common / td_book / h_buffer, c_pointer, pointer, hid, kind, n_call,
     &      l_limit, step, h_bin, n_hist, h_buffer_p, c_buffer_p, c_buffer
c local
      integer j, k, hist_id
	real x, y
c begin
      hist_id = hid( HID_N )
      if(hist_id .eq. -1) then
         write(*,*) 'warning: undefined histogram ID', HID_N
         return
      endif
      x = (data_x - l_limit(1,hist_id)) / step(1,hist_id)
      y = (data_y - l_limit(2,hist_id)) / step(2,hist_id)
      j = int(x - 1.e-4)
      k = int(y - 1.e-4)
      if(     x .ge. - 1.e-4 .and. j .lt. h_bin(1,hist_id)
     &  .and. y .ge. - 1.e-4 .and. k .lt. h_bin(2,hist_id)  ) then
        j = j + k * h_bin(1,hist_id) + pointer(hist_id)
        h_buffer(j) = h_buffer(j) + weight
      Endif
      n_call(hist_id) = n_call(hist_id) + 1
      Return
      End


      subroutine td_Houtput(unit, HID_N, cf, peak_limit, cont_n)
      Implicit NONE
c input
      integer unit, HID_N, cont_n
	real peak_limit
      character*(*) cf
      character*(5) ID_buffer
c common
	integer space_max, h_max, hn_max, c_max
      parameter ( space_max = 400000, h_max = 2000,
     & hn_max=10000, c_max = 140000 )
      real h_buffer( space_max )
      integer pointer(h_max), c_pointer(3,h_max),
     &      hid(hn_max), kind(h_max), n_call(h_max)
      real l_limit(2,h_max), step(2,h_max), h_bin(2,h_max)
      integer n_hist, h_buffer_p, c_buffer_p
      character*(c_max) c_buffer
      common / td_book / h_buffer, c_pointer, pointer, hid, kind, n_call,
     &      l_limit, step, h_bin, n_hist, h_buffer_p, c_buffer_p, c_buffer
	common /openf/ open, new_open
	logical open, new_open
c local
      integer hist_id, itb, ite, j, k
      real x, y, z, max_cnt
c begin
      hist_id = hid( HID_N )
      if(hist_id .eq. -1) then
	   write(*,*) 'Warning: no such histgram ID = ', HID_N
	   return
	endif
      if(.not.open) then
	   write(*,*) 'logical unit is not open : unit=', unit, 
     &	' ID = ', HID_N
	   return
	else
         if(new_open) then
		new_open = .false.
	   else
	      If(cf(1:1) .eq. 'n') then
		   write(unit,*) 'new plot'
	      endif
	   endif
	   If(cf(1:1) .eq. 'n' .or. cf(1:1) .eq. 't') then
		write(unit,*) 'set color white'
            itb = c_pointer(1,hist_id)
            ite = c_pointer(2,hist_id) - 1
	      write(ID_buffer,'(i5)') HID_N+hn_max
            write(unit,*) 'title top "'//ID_buffer(2:5)//
     &	   ': '//c_buffer(itb:ite)//'"'
            itb = c_pointer(2,hist_id)
            ite = c_pointer(3,hist_id) - 1
            write(unit,*) 'title bottom "'//c_buffer(itb:ite)//'"'
            itb = c_pointer(3,hist_id)
            if(hist_id .lt. n_hist) then
               ite = c_pointer(1,hist_id+1) - 1
            else
               ite = c_buffer_p
            endif
            write(unit,*) 'title left "'//c_buffer(itb:ite)//'"'
            if(kind( hist_id ) .eq. 1) then
               write(unit,*) 'set limit x',
     &            l_limit(1,hist_id), 
     &		l_limit(1,hist_id) + step(1,hist_id) * h_bin(1,hist_id)
            else
               write(unit,*) 'set cycle solid'
               write(unit,*) 'set secondary solid'
               write(unit,*) 'set limit x',
     &            l_limit(1,hist_id), l_limit(1,hist_id) 
     &		   + step(1,hist_id) * h_bin(1,hist_id)
               write(unit,*) 'set limit y',
     &            l_limit(2,hist_id), l_limit(2,hist_id) 
     &		   + step(2,hist_id) * h_bin(2,hist_id)
            endif
	   else If(cf(1:1) .eq. 'w') then
		write(unit,*) 'set color white'
	   else If(cf(1:1) .eq. 'y') then
		write(unit,*) 'set color yellow'
	   else If(cf(1:1) .eq. 'b') then
		write(unit,*) 'set color blue'
	   else If(cf(1:1) .eq. 'c') then
		write(unit,*) 'set color cyan'
	   else If(cf(1:1) .eq. 'g') then
		write(unit,*) 'set color green'
	   else If(cf(1:1) .eq. 'm') then
		write(unit,*) 'set color magenta'
	   else If(cf(1:1) .eq. 'r') then
		write(unit,*) 'set color red'
	   endif	
	endif
         if(kind( hist_id ) .eq. 1) then
            do j = 1, h_bin(1,hist_id)
               x = l_limit(1,hist_id) + step(1,hist_id) * (j-0.5)
               y = h_buffer( pointer(hist_id) + (j-1) )
               write(unit,*) x, y
            enddo
            write(unit,*) 'hist'
         else
            write(unit,*) 'read mesh'
            write(unit,*) 'for y= '
            write(unit,100) ( (l_limit(2,hist_id) + step(2,hist_id) * (k-0.5)), k = 1, h_bin(2,hist_id))
100		format(10e14.5)
            max_cnt = 0.
            Do j = 1, h_bin(1,hist_id)
               x = l_limit(1,hist_id) + step(1,hist_id) * (j-0.5)
               write(unit,*) 'x=', x,' z='
               write(unit,100) ( (h_buffer( pointer(hist_id) + (j-1) + h_bin(1,hist_id)*(k-1) )),
     &              k = 1, h_bin(2,hist_id) )
               do k = 1, h_bin(2,hist_id)
                  z = h_buffer( pointer(hist_id) + (j-1) + h_bin(1,hist_id)*(k-1) )
                  max_cnt = max(max_cnt, z)
               enddo
            enddo
            write(unit,*) 'contour cycle solid from ',0.,
     &                  ' to ',max_cnt*peak_limit,' n=',cont_n
         endif
      return
      end


      subroutine td_HoutputLog(unit, HID_N, cf, peak_limit, cont_n)
      Implicit NONE
c input
      integer unit, HID_N, cont_n
	real peak_limit
      character*(*) cf
      character*(5) ID_buffer
c common
	integer space_max, h_max, hn_max, c_max
      parameter ( space_max = 400000, h_max = 2000,
     & hn_max=10000, c_max = 140000 )
      real h_buffer( space_max )
      integer pointer(h_max), c_pointer(3,h_max),
     &      hid(hn_max), kind(h_max), n_call(h_max)
      real l_limit(2,h_max), step(2,h_max), h_bin(2,h_max)
      integer n_hist, h_buffer_p, c_buffer_p
      character*(c_max) c_buffer
      common / td_book / h_buffer, c_pointer, pointer, hid, kind, n_call,
     &      l_limit, step, h_bin, n_hist, h_buffer_p, c_buffer_p, c_buffer
	common /openf/ open, new_open
	logical open, new_open
c local
      integer hist_id, itb, ite, j, k
      real x, y, max_cnt
      	real zb(500)
c begin
      hist_id = hid( HID_N )
      if(hist_id .eq. -1) then
	   write(*,*) 'Warning: no such histgram ID = ', HID_N
	   return
	endif
      if(.not.open) then
	   write(*,*) 'logical unit is not open : unit=', unit, 
     &	' ID = ', HID_N
	   return
	else
         if(new_open) then
		new_open = .false.
	   else
	      If(cf(1:1) .eq. 'n') then
		   write(unit,*) 'new plot'
	      endif
	   endif
	   If(cf(1:1) .eq. 'n') then
		write(unit,*) 'set color white'
            itb = c_pointer(1,hist_id)
            ite = c_pointer(2,hist_id) - 1
	      write(ID_buffer,'(i5)') HID_N+hn_max
            write(unit,*) 'title top "'//ID_buffer(2:5)//
     &	   ': '//c_buffer(itb:ite)//': LOG plot"'
c	   write(*,*) 'td_Houtput', unit, ' --'//c_buffer(itb:ite)//'-- '
            itb = c_pointer(2,hist_id)
            ite = c_pointer(3,hist_id) - 1
            write(unit,*) 'title bottom "'//c_buffer(itb:ite)//'"'
            itb = c_pointer(3,hist_id)
            if(hist_id .lt. n_hist) then
               ite = c_pointer(1,hist_id+1) - 1
            else
               ite = c_buffer_p
            endif
            write(unit,*) 'title left "'//c_buffer(itb:ite)//'"'
            if(kind( hist_id ) .eq. 1) then
               write(unit,*) 'set limit x',
     &            l_limit(1,hist_id), l_limit(1,hist_id) 
     &		+ step(1,hist_id) * h_bin(1,hist_id)
            else
               write(unit,*) 'set cycle solid'
               write(unit,*) 'set secondary solid'
               write(unit,*) 'set limit x',
     &            l_limit(1,hist_id), l_limit(1,hist_id) 
     &		+ step(1,hist_id) * h_bin(1,hist_id)
               write(unit,*) 'set limit y',
     &            l_limit(2,hist_id), l_limit(2,hist_id) 
     &		+ step(2,hist_id) * h_bin(2,hist_id)
            endif
	   else If(cf(1:1) .eq. 'w') then
		write(unit,*) 'set color white'
	   else If(cf(1:1) .eq. 'y') then
		write(unit,*) 'set color yellow'
	   else If(cf(1:1) .eq. 'b') then
		write(unit,*) 'set color blue'
	   else If(cf(1:1) .eq. 'c') then
		write(unit,*) 'set color cyan'
	   else If(cf(1:1) .eq. 'g') then
		write(unit,*) 'set color green'
	   else If(cf(1:1) .eq. 'm') then
		write(unit,*) 'set color magenta'
	   else If(cf(1:1) .eq. 'r') then
		write(unit,*) 'set color red'
	   endif	
	endif
         if(kind( hist_id ) .eq. 1) then
            write(unit,*) 'set scale y log'
            do j = 1, h_bin(1,hist_id)
               x = l_limit(1,hist_id) + step(1,hist_id) * (j-0.5)
               y = h_buffer( pointer(hist_id) + (j-1) )
               write(unit,*) x, y
            enddo
            write(unit,*) 'hist'
         else
            write(unit,*) 'read mesh'
            write(unit,*) 'for y= '
            write(unit,100) ( (l_limit(2,hist_id) + step(2,hist_id) * (k-0.5)), k = 1, h_bin(2,hist_id))
100		format(10e14.5)
            max_cnt = 0.
            Do j = 1, h_bin(1,hist_id)
               x = l_limit(1,hist_id) + step(1,hist_id) * (j-0.5)
               do k = 1, h_bin(2,hist_id)
                  if( h_buffer( pointer(hist_id) + (j-1) + h_bin(1,hist_id)*(k-1) ) .le. 1.) then
                     zb(k) = 0.
                  else
                     zb(k) = log(h_buffer( pointer(hist_id) + (j-1) + h_bin(1,hist_id)*(k-1) ))
                  endif
                  max_cnt = max(max_cnt, zb(k))
               enddo
               write(unit,*) 'x=', x,' z='
               write(unit,100) ( (zb(k)), k = 1, h_bin(2,hist_id) )
            enddo
            write(unit,*) 'contour cycle solid from ',0.,
     &                  ' to ',max_cnt*peak_limit,' n=',cont_n
         endif
      return
      end


      subroutine td_Hcommand(unit, command)
      Implicit NONE
c input
      integer unit
      character*(*) command
	write(unit,*) command
	return
	end


      subroutine td_Hopen(io_unit, fname)
      Implicit NONE
c input
      integer io_unit, c_len
      character*(*) fname
      character*80 file_name
	common /openf/ open, new_open
	logical open, new_open
c format
100   format(Q,A)
c begin
      read(fname, 100) c_len, file_name
      Open ( unit = io_unit,
     &     file = file_name(1:c_len)//'.top',
     &     status = 'unknown' )
	open = .true.
	new_open = .true.
c	write(*,*) '##### open unit', io_unit, ' --'//file_name(1:c_len)//' --'
	return
	end


      subroutine td_Hclose(unit)
      Implicit NONE
	integer unit
	common /openf/ open, new_open
	logical open, new_open
c begin
c	write(*,*) 'close unit', unit
	close( unit )
	open = .false.
	return
	end


